/* ----------------------------------------------------------------------------
 * This file was automatically generated by SWIG (http://www.swig.org).
 * Version 1.3.24
 *
 * Do not make changes to this file unless you know what you are doing--modify
 * the SWIG interface file instead.
 * ----------------------------------------------------------------------------- */

package org.sbml.libsbml;

public class ASTNode {
   private long swigCPtr;
   protected boolean swigCMemOwn;

   protected ASTNode(long cPtr, boolean cMemoryOwn)
   {
     swigCMemOwn = cMemoryOwn;
     swigCPtr    = cPtr;
   }

   protected static long getCPtr(ASTNode obj)
   {
     return (obj == null) ? 0 : obj.swigCPtr;
   }

   protected static long getCPtrAndDisown (ASTNode obj)
   {
     long ptr = 0;

     if (obj != null)
     {
       ptr             = obj.swigCPtr;
       obj.swigCMemOwn = false;
     }

     return ptr;
   }

  protected void finalize() {
    delete();
  }

  public void delete() {
    if(swigCPtr != 0 && swigCMemOwn) {
      swigCMemOwn = false;
      libsbmlJNI.delete_ASTNode(swigCPtr);
    }
    swigCPtr = 0;
  }

  
  /**
   * Creates a new ASTNode.
   *
   * By default, node will have a type of AST_UNKNOWN and should be set to
   * something else as soon as possible.
   */
public ASTNode(int type) {
    this(libsbmlJNI.new_ASTNode__SWIG_0(type), true);
  }

  
  /**
   * Creates a new ASTNode.
   *
   * By default, node will have a type of AST_UNKNOWN and should be set to
   * something else as soon as possible.
   */
public ASTNode() {
    this(libsbmlJNI.new_ASTNode__SWIG_1(), true);
  }

  
  /**
   * Attempts to convert this ASTNode to a canonical form and returns true
   * if the conversion succeeded, false otherwise.
   *
   * The rules determining the canonical form conversion are as follows:
   *
   *   1. If the node type is AST_NAME and the node name matches
   *   'ExponentialE', 'Pi', 'True' or 'False' the node type is converted
   *   to the corresponding AST_CONSTANT type.
   *
   *   2. If the node type is an AST_FUNCTION and the node name matches an
   *   L1 or L2 (MathML) function name, logical operator name, or
   *   relational operator name, the node is converted to the correspnding
   *   AST_FUNCTION, AST_LOGICAL or AST_CONSTANT type.
   *
   * L1 function names are searched first, so canonicalizing 'log' will
   * result in a node type of AST_FUNCTION_LN (see L1 Specification,
   * Appendix C).
   *
   * Some canonicalizations result in a structural converion of the nodes
   * (by adding a child).  For example, a node with L1 function name 'sqr'
   * and a single child node (the argument) will be transformed to a node
   * of type AST_FUNCTION_POWER with two children.  The first child will
   * remain unchanged, but the second child will be an ASTNode of type
   * AST_INTEGER and a value of 2.  The function names that result in
   * structural changes are: log10, sqr and sqrt.
   */
public boolean canonicalize() {
    return libsbmlJNI.ASTNode_canonicalize(swigCPtr);
  }

  
  /**
   * Adds the given node as a child of this ASTNode.  Child nodes are added
   * in-order from 'left-to-right'.
   */
public void addChild(ASTNode child) {
    libsbmlJNI.ASTNode_addChild(swigCPtr, ASTNode.getCPtrAndDisown(child));
  }

  
  /**
   * Adds the given node as a child of this ASTNode.  This method adds
   * child nodes from 'right-to-left'.
   */
public void prependChild(ASTNode child) {
    libsbmlJNI.ASTNode_prependChild(swigCPtr, ASTNode.getCPtrAndDisown(child));
  }

  
  /**
   * @return a copy of this ASTNode and all its children.  The caller owns
   * the returned ASTNode and is reponsible for deleting it.
   */
public ASTNode deepCopy() {
    long cPtr = libsbmlJNI.ASTNode_deepCopy(swigCPtr);
    return (cPtr == 0) ? null : new ASTNode(cPtr, true);
  }

  
  /**
   * @return the nth child of this ASTNode or NULL if this node has no nth
   * child (n > ASTNode_getNumChildren() - 1).
   */
public ASTNode getChild(long n) {
    long cPtr = libsbmlJNI.ASTNode_getChild(swigCPtr, n);
    return (cPtr == 0) ? null : new ASTNode(cPtr, false);
  }

  
  /**
   * @return the left child of this ASTNode.  This is equivalent to
   * getChild(0);
   */
public ASTNode getLeftChild() {
    long cPtr = libsbmlJNI.ASTNode_getLeftChild(swigCPtr);
    return (cPtr == 0) ? null : new ASTNode(cPtr, false);
  }

  
  /**
   * @return the right child of this ASTNode or NULL if this node has no
   * right child.  If getNumChildren() > 1, then this is equivalent to:
   *
   *   getChild( getNumChildren() - 1);
   */
public ASTNode getRightChild() {
    long cPtr = libsbmlJNI.ASTNode_getRightChild(swigCPtr);
    return (cPtr == 0) ? null : new ASTNode(cPtr, false);
  }

  
  /**
   * @return the number of children of this ASTNode or 0 is this node has
   * no children.
   */
public long getNumChildren() {
    return libsbmlJNI.ASTNode_getNumChildren(swigCPtr);
  }

  
  /**
   * @return the value of this ASTNode as a single character.  This
   * function should be called only when getType() is one of AST_PLUS,
   * AST_MINUS, AST_TIMES, AST_DIVIDE or AST_POWER.
   */
public char getCharacter() {
    return libsbmlJNI.ASTNode_getCharacter(swigCPtr);
  }

  
  /**
   * @return the value of this ASTNode as a (long) integer.  This function
   * should be called only when getType() == AST_INTEGER.
   */
public int getInteger() {
    return libsbmlJNI.ASTNode_getInteger(swigCPtr);
  }

  
  /**
   * @return the value of this ASTNode as a string.  This function may be
   * called on nodes that are not operators (isOperator() == false) or
   * numbers (isNumber() == false).
   */
public String getName() {
    return libsbmlJNI.ASTNode_getName(swigCPtr);
  }

  
  /**
   * @return the value of the numerator of this ASTNode.  This function
   * should be called only when getType() == AST_RATIONAL.
   */
public int getNumerator() {
    return libsbmlJNI.ASTNode_getNumerator(swigCPtr);
  }

  
  /**
   * @return the value of the denominator of this ASTNode.  This function
   * should be called only when getType() == AST_RATIONAL.
   */
public int getDenominator() {
    return libsbmlJNI.ASTNode_getDenominator(swigCPtr);
  }

  
  /**
   * @return the value of this ASTNode as a real (double).  This function
   * should be called only when isReal() == true.
   *
   * This function performs the necessary arithmetic if the node type is
   * AST_REAL_E (mantissa * $10^exponent$) or AST_RATIONAL (numerator /
   * denominator).
   */
public double getReal() {
    return libsbmlJNI.ASTNode_getReal(swigCPtr);
  }

  
  /**
   * @return the value of the mantissa of this ASTNode.  This function
   * should be called only when getType() is AST_REAL_E or AST_REAL.  If
   * AST_REAL, this method is identical to getReal().
   */
public double getMantissa() {
    return libsbmlJNI.ASTNode_getMantissa(swigCPtr);
  }

  
  /**
   * @return the value of the exponent of this ASTNode.  This function
   * should be called only when getType() is AST_REAL_E or AST_REAL.
   */
public int getExponent() {
    return libsbmlJNI.ASTNode_getExponent(swigCPtr);
  }

  
  /**
   * @return the precedence of this ASTNode (as defined in the SBML L1
   * specification).
   */
public int getPrecedence() {
    return libsbmlJNI.ASTNode_getPrecedence(swigCPtr);
  }

  
  /**
   * @return the type of this ASTNode.
   */
public int getType() {
    return libsbmlJNI.ASTNode_getType(swigCPtr);
  }

  
  /**
   * @return true if this ASTNode is a boolean (a logical operator, a
   * relational operator, or the constants true or false), false otherwise.
   */
public boolean isBoolean() {
    return libsbmlJNI.ASTNode_isBoolean(swigCPtr);
  }

  
  /**
   * @return true if this ASTNode is a MathML constant (true, false, pi,
   * exponentiale), false otherwise.
   */
public boolean isConstant() {
    return libsbmlJNI.ASTNode_isConstant(swigCPtr);
  }

  
  /**
   * @return true if this ASTNode is a function in SBML L1, L2 (MathML)
   * (everything from abs() to tanh()) or user-defined, false otherwise.
   */
public boolean isFunction() {
    return libsbmlJNI.ASTNode_isFunction(swigCPtr);
  }

  
  /**
   * @return true if this ASTNode is of type AST_INTEGER, false otherwise.
   */
public boolean isInteger() {
    return libsbmlJNI.ASTNode_isInteger(swigCPtr);
  }

  
  /**
   * @return true if this ASTNode is of type AST_LAMBDA, false otherwise.
   */
public boolean isLambda() {
    return libsbmlJNI.ASTNode_isLambda(swigCPtr);
  }

  
  /**
   * @return true if the given ASTNode represents a log10() function, false
   * otherwise.
   *
   * More precisley, the node type is AST_FUNCTION_LOG with two children
   * the first of which is an AST_INTEGER equal to 10.
   */
public boolean isLog10() {
    return libsbmlJNI.ASTNode_isLog10(swigCPtr);
  }

  
  /**
   * @return true if this ASTNode is a MathML logical operator (and, or,
   * not, xor), false otherwise.
   */
public boolean isLogical() {
    return libsbmlJNI.ASTNode_isLogical(swigCPtr);
  }

  
  /**
   * @return true if this ASTNode is a user-defined variable name in SBML
   * L1, L2 (MathML) or the special symbols delay or time, false otherwise.
   */
public boolean isName() {
    return libsbmlJNI.ASTNode_isName(swigCPtr);
  }

  
  /**
   * @return true if this ASTNode is a number, false otherwise.
   *
   * This is functionally equivalent to:
   *
   *   isInteger() || isReal().
   */
public boolean isNumber() {
    return libsbmlJNI.ASTNode_isNumber(swigCPtr);
  }

  
  /**
   * @return true if this ASTNode is an operator, false otherwise.
   * Operators are: +, -, *, / and \^ (power).
   */
public boolean isOperator() {
    return libsbmlJNI.ASTNode_isOperator(swigCPtr);
  }

  
  /**
   * @return true if this ASTNode is of type AST_RATIONAL, false otherwise.
   */
public boolean isRational() {
    return libsbmlJNI.ASTNode_isRational(swigCPtr);
  }

  
  /**
   * @return true if the value of this ASTNode can represented as a real
   * number, false otherwise.
   *
   * To be a represented as a real number, this node must be of one of the
   * following types: AST_REAL, AST_REAL_E or AST_RATIONAL.
   */
public boolean isReal() {
    return libsbmlJNI.ASTNode_isReal(swigCPtr);
  }

  
  /**
   * @return true if this ASTNode is a MathML relational operator (==, >=,
   * >, <=, < !=), false otherwise.
   */
public boolean isRelational() {
    return libsbmlJNI.ASTNode_isRelational(swigCPtr);
  }

  
  /**
   * @return true if the given ASTNode represents a sqrt() function, false
   * otherwise.
   *
   * More precisley, the node type is AST_FUNCTION_ROOT with two children
   * the first of which is an AST_INTEGER equal to 2.
   */
public boolean isSqrt() {
    return libsbmlJNI.ASTNode_isSqrt(swigCPtr);
  }

  
  /**
   * @return true if this ASTNode is a unary minus, false otherwise.
   *
   * For numbers, unary minus nodes can be 'collapsed' by negating the
   * number.  In fact, SBML_parseFormula() does this during its parse.
   * However, unary minus nodes for symbols (AST_NAMES) cannot be
   * 'collapsed', so this predicate function is necessary.
   *
   * A node is defined as a unary minus node if it is of type AST_MINUS and
   * has exactly one child.
   */
public boolean isUMinus() {
    return libsbmlJNI.ASTNode_isUMinus(swigCPtr);
  }

  
  /**
   * @return true if this ASTNode is of type AST_UNKNOWN, false otherwise.
   */
public boolean isUnknown() {
    return libsbmlJNI.ASTNode_isUnknown(swigCPtr);
  }

  
  /**
   * Sets the value of this ASTNode to the given character.  If character
   * is one of '+', '-', '*', '/' or '\^', the node type will be set
   * accordingly.  For all other characters, the node type will be set to
   * AST_UNKNOWN.
   */
public void setCharacter(char value) {
    libsbmlJNI.ASTNode_setCharacter(swigCPtr, value);
  }

  
  /**
   * Sets the value of this ASTNode to the given name.
   *
   * The node type will be set (to AST_NAME) ONLY IF the ASTNode was
   * previously an operator (isOperator(node) == true) or number
   * (isNumber(node) == true).  This allows names to be set for
   * AST_FUNCTIONs and the like.
   */
public void setName(String name) {
    libsbmlJNI.ASTNode_setName(swigCPtr, name);
  }

  
  /**
   * Sets the value of this ASTNode to the given real (double) in two
   * parts: the mantissa and the exponent.  The node type is set to
   * AST_REAL_E.
   */
public void setValue(int numerator, int denominator) {
    libsbmlJNI.ASTNode_setValue__SWIG_0(swigCPtr, numerator, denominator);
  }

  
  /**
   * Sets the value of this ASTNode to the given real (double) in two
   * parts: the mantissa and the exponent.  The node type is set to
   * AST_REAL_E.
   */
public void setValue(double value) {
    libsbmlJNI.ASTNode_setValue__SWIG_1(swigCPtr, value);
  }

  
  /**
   * Sets the value of this ASTNode to the given real (double) in two
   * parts: the mantissa and the exponent.  The node type is set to
   * AST_REAL_E.
   */
public void setValue(double mantissa, int exponent) {
    libsbmlJNI.ASTNode_setValue__SWIG_2(swigCPtr, mantissa, exponent);
  }

  
  /**
   * Sets the type of this ASTNode to the given ASTNodeType.
   */
public void setType(int type) {
    libsbmlJNI.ASTNode_setType(swigCPtr, type);
  }

}
