/* ----------------------------------------------------------------------------
 * This file was automatically generated by SWIG (http://www.swig.org).
 * Version 1.3.24
 *
 * Do not make changes to this file unless you know what you are doing--modify
 * the SWIG interface file instead.
 * ----------------------------------------------------------------------------- */

package org.sbml.libsbml;

import java.io.File;

public class SBMLReader {
   private long swigCPtr;
   protected boolean swigCMemOwn;

   protected SBMLReader(long cPtr, boolean cMemoryOwn)
   {
     swigCMemOwn = cMemoryOwn;
     swigCPtr    = cPtr;
   }

   protected static long getCPtr(SBMLReader obj)
   {
     return (obj == null) ? 0 : obj.swigCPtr;
   }

   protected static long getCPtrAndDisown (SBMLReader obj)
   {
     long ptr = 0;

     if (obj != null)
     {
       ptr             = obj.swigCPtr;
       obj.swigCMemOwn = false;
     }

     return ptr;
   }

  protected void finalize() {
    delete();
  }

  public void delete() {
    if(swigCPtr != 0 && swigCMemOwn) {
      swigCMemOwn = false;
      libsbmlJNI.delete_SBMLReader(swigCPtr);
    }
    swigCPtr = 0;
  }

  public SBMLDocument readSBML (String filename)
  {
    File   file    = new java.io.File(filename);
    String abspath = file.getAbsolutePath();
    long   cPtr    = libsbmlJNI.SBMLReader_readSBMLInternal(swigCPtr, abspath);
    return (cPtr == 0) ? null : new SBMLDocument(cPtr, true);
  }

  
  /**
   * Creates a new SBMLReader and returns it.
   *
   * By default schema validation is off (XML_SCHEMA_VALIDATION_NONE) and
   * schemaFilenames are empty.
   */
public SBMLReader(int level) {
    this(libsbmlJNI.new_SBMLReader__SWIG_0(level), true);
  }

  
  /**
   * Creates a new SBMLReader and returns it.
   *
   * By default schema validation is off (XML_SCHEMA_VALIDATION_NONE) and
   * schemaFilenames are empty.
   */
public SBMLReader() {
    this(libsbmlJNI.new_SBMLReader__SWIG_1(), true);
  }

  
  /**
   * @return the schema filename used by this SBMLReader to validate SBML
   * Level 1 version 1 documents.
   */
public String getSchemaFilenameL1v1() {
    return libsbmlJNI.SBMLReader_getSchemaFilenameL1v1(swigCPtr);
  }

  
  /**
   * @return the schema filename used by this SBMLReader to validate SBML
   * Level 1 version 2 documents.
   */
public String getSchemaFilenameL1v2() {
    return libsbmlJNI.SBMLReader_getSchemaFilenameL1v2(swigCPtr);
  }

  
  /**
   * @return the schema filename used by this SBMLReader to validate SBML
   * Level 2 version 1 documents.
   */
public String getSchemaFilenameL2v1() {
    return libsbmlJNI.SBMLReader_getSchemaFilenameL2v1(swigCPtr);
  }

  
  /**
   * Sets the schema validation level used by this SBMLReader.
   */
public int getSchemaValidationLevel() {
    return libsbmlJNI.SBMLReader_getSchemaValidationLevel(swigCPtr);
  }

  private SBMLDocument readSBMLInternal(String filename) {
    long cPtr = libsbmlJNI.SBMLReader_readSBMLInternal(swigCPtr, filename);
    return (cPtr == 0) ? null : new SBMLDocument(cPtr, true);
  }

  
  /**
   * Reads an SBML document from the given XML string.
   *
   * The XML string must be complete and legal XML document.  Among other
   * things, it must start with an XML processing instruction.  For e.g.,:
   *
   *   <?xml version='1.0' encoding='UTF-8'?>
   *
   * This method will log a fatal error if the XML string is not SBML.  See
   * the method documentation for readSBML(filename) for example error
   * checking code.
   *
   * @return a pointer to the SBMLDocument read.
   */
public SBMLDocument readSBMLFromString(String xml) {
    long cPtr = libsbmlJNI.SBMLReader_readSBMLFromString(swigCPtr, xml);
    return (cPtr == 0) ? null : new SBMLDocument(cPtr, true);
  }

  
  /**
   * Sets the schema filename used by this SBMLReader to validate SBML
   * Level 1 version 1 documents.
   *
   * The filename should be either i) an absolute path or ii) relative to
   * the directory contain the SBML file(s) to be read.
   */
public void setSchemaFilenameL1v1(String filename) {
    libsbmlJNI.SBMLReader_setSchemaFilenameL1v1(swigCPtr, filename);
  }

  
  /**
   * Sets the schema filename used by this SBMLReader to validate SBML
   * Level 1 version 2 documents.
   *
   * The filename should be either i) an absolute path or ii) relative to
   * the directory contain the SBML file(s) to be read.
   */
public void setSchemaFilenameL1v2(String filename) {
    libsbmlJNI.SBMLReader_setSchemaFilenameL1v2(swigCPtr, filename);
  }

  
  /**
   * Sets the schema filename used by this SBMLReader to validate SBML Level
   * 2 version 1 documents.
   *
   * The filename should be either i) an absolute path or ii) relative to the
   * directory contain the SBML file(s) to be read.
   */
public void setSchemaFilenameL2v1(String filename) {
    libsbmlJNI.SBMLReader_setSchemaFilenameL2v1(swigCPtr, filename);
  }

  
  /**
   * Sets the schema validation level used by this SBMLReader.
   *
   * The levels are:
   *
   *   XML_SCHEMA_VALIDATION_NONE (0) turns schema validation off.
   *
   *   XML_SCHEMA_VALIDATION_BASIC (1) validates an XML instance document
   *   against an XML Schema.  Those who wish to perform schema checking on
   *   SBML documents should use this option.
   *
   *   XML_SCHEMA_VALIDATION_FULL (2) validates both the instance document
   *   itself *and* the XML Schema document.  The XML Schema document is
   *   checked for violation of particle unique attribution constraints and
   *   particle derivation restrictions, which is both time-consuming and
   *   memory intensive.
   */
public void setSchemaValidationLevel(int level) {
    libsbmlJNI.SBMLReader_setSchemaValidationLevel(swigCPtr, level);
  }

}
