# This file was automatically generated by SWIG
package LibSBML;
require Exporter;
require DynaLoader;
@ISA = qw(Exporter DynaLoader);
package LibSBMLc;
bootstrap LibSBML;
package LibSBML;
@EXPORT = qw( );
=head1 NAME

LibSBML  -- interface to the libSBML library

=head1 SYNOPSIS

  use File::Spec;
  use LibSBML;
  use strict;

  my $file     = File::Spec->rel2abs('FOO.xml');
  my $reader   = new LibSBML::SBMLReader;
  my $document = $rd->readSBML($file);
  my $model    = $document->getModel();
  ... 

=head1 DESCRIPTION

The LibSBML.pm package gives access to almost all functions in libSBML
(http://sbml.org). The Perl wrapper is generated using SWIG
http://www.swig.org/ with relatively little manual intervention.

=head1 AUTHORS

 Christoph Flamm <xtof@tbi.univie.ac.at>
 Rainer Machne   <raim@tbi.univie.ac.at>

=head1 FUNCTION INDEX

=over 8

=item SBMLReader::SBMLReader

Creates a new SBMLReader and returns it. By default schema validation is off (XML_SCHEMA_VALIDATION_NONE) and schemaFilenames are empty.

=item SBMLReader::getSchemaFilenameL1v1

Returns the schema filename used by this SBMLReader to validate SBML Level 1 version 1 documents.

=item SBMLReader::getSchemaFilenameL1v2

Returns the schema filename used by this SBMLReader to validate SBML Level 1 version 2 documents.

=item SBMLReader::getSchemaFilenameL2v1

Returns the schema filename used by this SBMLReader to validate SBML Level 2 version 1 documents.

=item SBMLReader::getSchemaValidationLevel

Sets the schema validation level used by this SBMLReader.

=item SBMLReader::readSBML

Reads an SBML document from the given file. If filename does not exist or is not an SBML file, a fatal error will be logged. Errors can be identified by their unique ids, e.g.: <code> SBMLDocument d = reader.readSBML(filename); if (d->getNumFatals() E<gt> 0) { if (d->getFatal(0)->getId() == SBML_READ_ERROR_FILE_NOT_FOUND) if (d->getFatal(0)->getId() == SBML_READ_ERROR_NOT_SBML) } </code> Returns a pointer to the SBMLDocument read.

=item SBMLReader::readSBMLFromString

Reads an SBML document from the given XML string. The XML string must be complete and legal XML document. Among other things, it must start with an XML processing instruction. For e.g.,: <?xml version='1.0' encoding='UTF-8'?> This method will log a fatal error if the XML string is not SBML. See the method documentation for readSBML(filename) for example error checking code. Returns a pointer to the SBMLDocument read.

=item SBMLReader::setSchemaFilenameL1v1

Sets the schema filename used by this SBMLReader to validate SBML Level 1 version 1 documents. The filename should be either i) an absolute path or ii) relative to the directory contain the SBML file(s) to be read.

=item SBMLReader::setSchemaFilenameL1v2

Sets the schema filename used by this SBMLReader to validate SBML Level 1 version 2 documents. The filename should be either i) an absolute path or ii) relative to the directory contain the SBML file(s) to be read.

=item SBMLReader::setSchemaFilenameL2v1

Sets the schema filename used by this SBMLReader to validate SBML Level 2 version 1 documents. The filename should be either i) an absolute path or ii) relative to the directory contain the SBML file(s) to be read.

=item SBMLReader::setSchemaValidationLevel

Sets the schema validation level used by this SBMLReader. The levels are: XML_SCHEMA_VALIDATION_NONE (0) turns schema validation off. XML_SCHEMA_VALIDATION_BASIC (1) validates an XML instance document against an XML Schema. Those who wish to perform schema checking on SBML documents should use this option. XML_SCHEMA_VALIDATION_FULL (2) validates both the instance document itself and the XML Schema document. The XML Schema document is checked for violation of particle unique attribution constraints and particle derivation restrictions, which is both time-consuming and memory intensive.

=item readSBML

Reads an SBML document from the given file. If filename does not exist or is not an SBML file, a fatal error will be logged. Errors can be identified by their unique ids, e.g.: <code> SBMLDocument_t d = SBMLReader_readSBML(reader, filename); if (SBMLDocument_getNumFatals(d) E<gt> 0) { ParseMessage_t pm = SBMLDocument_getFatal(d, 0); if (ParseMessage_getId(pm) == SBML_READ_ERROR_FILE_NOT_FOUND) if (ParseMessage_getId(pm) == SBML_READ_ERROR_NOT_SBML) } </code> Returns a pointer to the SBMLDocument read.

=item readSBMLFromString

Reads an SBML document from the given XML string. The XML string must be complete and legal XML document. Among other things, it must start with an XML processing instruction. For e.g.,: <?xml version='1.0' encoding='UTF-8'?> This method will log a fatal error if the XML string is not SBML. See the function documentation for readSBML(filename) for example error checking code. Returns a pointer to the SBMLDocument read.

=item SBMLWriter::SBMLWriter

Creates a new SBMLWriter.

=item SBMLWriter::setProgramName

Sets the name of this program, i.e. the one about to write out the SBMLDocument. If the program name and version are set (setProgramVersion()), the following XML comment, intended for human consumption, will be written at the beginning of the document: <!-- Created by <program name> version <program version> on yyyy-MM-dd HH:mm with libsbml version <libsbml version>. -->

=item SBMLWriter::setProgramVersion

Sets the version of this program, i.e. the one about to write out the SBMLDocument. If the program version and name are set (setProgramName()), the following XML comment, intended for human consumption, will be written at the beginning of the document: <!-- Created by <program name> version <program version> on yyyy-MM-dd HH:mm with libsbml version <libsbml version>. -->

=item SBMLWriter::write

Writes the given SBML document to filename. Returns true on success and false if the filename could not be opened for writing.

=item SBMLWriter::write

Writes the given SBML document to the output stream. Returns true on success and false if one of the underlying Xerces or Expat components fail (rare).

=item SBMLWriter::writeToString

Writes the given SBML document to an in-memory string and returns a pointer to it. The string is owned by the caller and should be freed (with free()) when no longer needed. Returns the string on success and 0 if one of the underlying Xerces or Expat components fail (rare).

=item writeSBML

Writes the given SBML document to filename. This convenience function is functionally equivalent to: SBMLWriter_writeSBML(SBMLWriter_create(), d, filename); Returns non-zero on success and zero if the filename could not be opened for writing.)

=item writeSBMLToString

Writes the given SBML document to an in-memory string and returns a pointer to it. The string is owned by the caller and should be freed (with free()) when no longer needed. This convenience function is functionally equivalent to: SBMLWriter_writeSBMLToString(SBMLWriter_create(), d); Returns the string on success and NULL if one of the underlying Xerces or Expat components fail (rare).

=item SBMLTypeCode_toString

Returns a human readable name for the given SBMLTypeCode_t. The caller does not own the returned string and is therefore not allowed to modify it.

=item SBase::init

SBase 'objects' are abstract, i.e., they are not created. Rather, specific 'subclasses' are created (e.g., Model) and their SBASE_FIELDS are initialized with this function. The type of the specific 'subclass' is indicated by the given SBMLTypeCode.

=item SBase::getTypeCode



=item SBase::getColumn



=item SBase::getLine



=item SBase::getMetaId



=item SBase::getNotes



=item SBase::getAnnotation



=item SBase::getNamespaces

Returns a list of XML namespaces defined on this SBML object.

=item SBase::hasNamespaces

Returns true if this SBML object has any XML namespaces defined on it, false otherwise.

=item SBase::isSetMetaId



=item SBase::isSetNotes



=item SBase::isSetAnnotation



=item SBase::setMetaId



=item SBase::setNotes



=item SBase::setAnnotation



=item SBase::toSBML

Returns the partial SBML that describes this SBML object.

=item SBase::unsetMetaId



=item SBase::unsetNotes



=item SBase::unsetAnnotation



=item ListOf::ListOf

Creates a new ListOf.

=item ListOf::accept

Accepts the given SBMLVisitor.

=item ListOf::append

Adds item to the end of this List.

=item ListOf::countIf

Returns the number of items in this List for which predicate(item) returns true. The typedef for ListItemPredicate is: int (ListItemPredicate) (const void item); where a return value of non-zero represents true and zero represents false.

=item ListOf::find

Returns the first occurrence of item1 in this List or NULL if item was not found. ListItemComparator is a pointer to a function used to find item. The typedef for ListItemComparator is: int (ListItemComparator) (const void item1, const void item2); The return value semantics are the same as for strcmp: -1 item1 E<lt> item2, 0 item1 == item 2 1 item1 E<gt> item2

=item ListOf::get

Returns the nth item in this List. If n E<gt> ListOf.getNumItems() returns 0.

=item ListOf::getNumItems

Returns the number of items in this List.

=item ListOf::prepend

Adds item to the beginning of this ListOf.

=item ListOf::remove

Removes the nth item from this List and returns a pointer to it. If n E<gt> ListOf.getNumItems() returns 0.

=item Model::Model

Creates a new Model, optionally with its id and name attributes set.

=item Model::accept

Accepts the given SBMLVisitor.

=item Model::getId

Returns the id of this Model.

=item Model::getName

Returns the name of this Model.

=item Model::isSetId

Returns true if the id of this Model has been set, false otherwise.

=item Model::isSetName

Returns true if the name of this Model has been set, false otherwise.

=item Model::moveAllIdsToNames

Moves the id field to the name field for this Model and all of its contituent UnitDefinitions, Compartments, Species, Parameters, and Reactions. This method is used for converting from L2 to L1. NOTE: Any object with its name field already set will be skipped. @see moveIdToName

=item Model::moveAllNamesToIds

Moves the name field to the id field for this Model and all of its contituent UnitDefinitions, Compartments, Species, Parameters, and Reactions. This method is used for converting from L1 to L2. NOTE: Any object with its id field already set will be skipped. @see moveNameToId

=item Model::moveIdToName

Moves the id field of this Model to its name field (iff name is not already set). This method is used for converting from L2 to L1.

=item Model::moveNameToId

Moves the name field of this Model to its id field (iff id is not already set). This method is used for converting from L1 to L2.

=item Model::setId

Sets the id of this Model to a copy of sid.

=item Model::setName

Sets the name of this Model to a copy of string (SName in L1).

=item Model::unsetId

Unsets the id of this Model.

=item Model::unsetName

Unsets the name of this Model.

=item Model::createFunctionDefinition

Creates a new FunctionDefinition inside this Model and returns it. This covenience method is equivalent to: addFunctionDefinition( FunctionDefinition() );

=item Model::createUnitDefinition

Creates a new UnitDefinition inside this Model and returns it. This covenience method is equivalent to: addUnitDefinition( UnitDefinition() );

=item Model::createUnit

Creates a new Unit inside this Model and returns a pointer to it. The Unit is added to the last UnitDefinition created. If a UnitDefinitions does not exist for this model, a new Unit is not created and NULL is returned.

=item Model::createCompartment

Creates a new Compartment inside this Model and returns it. This covenience method is equivalent to: addCompartment( Compartment() );

=item Model::createSpecies

Creates a new Species inside this Model and returns . This covenience method is equivalent to: addSpecies( Species() );

=item Model::createParameter

Creates a new Parameter inside this Model and returns. This covenience method is equivalent to: addParameter( Parameter() );

=item Model::createAssignmentRule

Creates a new AssignmentRule inside this Model and returns . This covenience method is equivalent to: addRule( AssignmentRule() ); (L2 only)

=item Model::createRateRule

Creates a new RateRule inside this Model and returns it. This covenience method is equivalent to: addRule( RateRule() ); (L2 only)

=item Model::createAlgebraicRule

Creates a new AlgebraicRule inside this Model and returns it. This covenience method is equivalent to: addRule( AlgebraicRule() );

=item Model::createCompartmentVolumeRule

Creates a new CompartmentVolumeRule inside this Model and returns. This covenience method is equivalent to: addRule( CompartmentVolumeRule() );

=item Model::createParameterRule

Creates a new ParameterRule inside this Model and returns it. This covenience method is equivalent to: addRule( ParameterRule() );

=item Model::createSpeciesConcentrationRule

Creates a new SpeciesConcentrationRule inside this Model and returns it. This covenience method is equivalent to: addRule( SpeciesConcentrationRule() );

=item Model::createReaction

Creates a new Reaction inside this Model and returns. This covenience method is equivalent to: addReaction( Reaction() );

=item Model::createReactant

Creates a new Reactant (i.e. SpeciesReference) inside this Model and returns a pointer to it. The SpeciesReference is added to the reactants of the last Reaction created. If a Reaction does not exist for this model, a new SpeciesReference is not created and NULL is returned.

=item Model::createProduct

Creates a new Product (i.e. SpeciesReference) inside this Model and returns a pointer to it. The SpeciesReference is added to the products of the last Reaction created. If a Reaction does not exist for this model, a new SpeciesReference is not created and NULL is returned.

=item Model::createModifier

Creates a new Modifer (i.e. ModifierSpeciesReference) inside this Model and returns a pointer to it. The ModifierSpeciesReference is added to the modifiers of the last Reaction created. If a Reaction does not exist for this model, a new ModifierSpeciesReference is not created and NULL is returned.

=item Model::createKineticLaw

Creates a new KineticLaw inside this Model and returns a pointer to it. The KineticLaw is associated with the last Reaction created. If a Reaction does not exist for this model, or a Reaction does exist, but already has a KineticLaw, a new KineticLaw is not created and NULL is returned.

=item Model::createKineticLawParameter

Creates a new Parameter (of a KineticLaw) inside this Model and returns a pointer to it. The Parameter is associated with the KineticLaw of the last Reaction created. If a Reaction does not exist for this model, or a KineticLaw for the Reaction, a new Parameter is not created and NULL is returned.

=item Model::createEvent

Creates a new Event inside this Model and returns. This covenience function is functionally equivalent to: addEvent( Event() );

=item Model::createEventAssignment

Creates a new EventAssignment inside this Model and returns a pointer to it. The EventAssignment is added to the the last Event created. If an Event does not exist for this model, a new EventAssignment is not created and NULL is returned.

=item Model::addFunctionDefinition

Adds the given FunctionDefinition to this Model.

=item Model::addUnitDefinition

Adds the given UnitDefinition to this Model.

=item Model::addCompartment

Adds the given Compartment to this Model.

=item Model::addSpecies

Adds the given Species to this Model.

=item Model::addParameter

Adds the given Parameter to this Model.

=item Model::addRule

Adds the given Rule to this Model.

=item Model::addReaction

Adds the given Reaction to this Model.

=item Model::addEvent

Adds the given Event to this Model.

=item Model::getListOfFunctionDefinitions

Returns the list of FunctionDefinitions for this Model.

=item Model::getListOfFunctionDefinitions

Returns the list of FunctionDefinitions for this Model.

=item Model::getListOfUnitDefinitions

Returns the list of UnitDefinitions for this Model.

=item Model::getListOfUnitDefinitions

Returns the list of UnitDefinitions for this Model.

=item Model::getListOfCompartments

Returns the list of Compartments for this Model.

=item Model::getListOfCompartments

Returns the list of Compartments for this Model.

=item Model::getListOfSpecies

Returns the list of Species for this Model.

=item Model::getListOfSpecies

Returns the list of Species for this Model.

=item Model::getListOfParameters

Returns the list of Parameters for this Model.

=item Model::getListOfParameters

Returns the list of Parameters for this Model.

=item Model::getListOfRules

Returns the list of Rules for this Model.

=item Model::getListOfRules

Returns the list of Rules for this Model.

=item Model::getListOfReactions

Returns the list of Rules for this Model.

=item Model::getListOfReactions

Returns the list of Rules for this Model.

=item Model::getListOfEvents

Returns the list of Rules for this Model.

=item Model::getListOfEvents

Returns the list of Rules for this Model.

=item Model::getFunctionDefinition

Returns the nth FunctionDefinition of this Model.

=item Model::getFunctionDefinition

Returns the FunctionDefinition in this Model with the given id or NULL if no such FunctionDefinition exists.

=item Model::getUnitDefinition

Returns the nth UnitDefinition of this Model.

=item Model::getUnitDefinition

Returns the UnitDefinition in this Model with the given id or NULL if no such UnitDefinition exists.

=item Model::getCompartment

Returns the nth Compartment of this Model.

=item Model::getCompartment

Returns the Compartment in this Model with the given id or NULL if no such Compartment exists.

=item Model::getSpecies

Returns the nth Species of this Model.

=item Model::getSpecies

Returns the Species in this Model with the given id or NULL if no such Species exists.

=item Model::getParameter

Returns the nth Parameter of this Model.

=item Model::getParameter

Returns the Parameter in this Model with the given id or NULL if no such Parameter exists.

=item Model::getRule

Returns the nth Rule of this Model.

=item Model::getReaction

Returns the nth Reaction of this Model.

=item Model::getReaction

Returns the Reaction in this Model with the given id or NULL if no such Reaction exists.

=item Model::getEvent

Returns the nth Event of this Model.

=item Model::getEvent

Returns the Event in this Model with the given id or NULL if no such Event exists.

=item Model::getNumFunctionDefinitions

Returns the number of FunctionDefinitions in this Model.

=item Model::getNumUnitDefinitions

Returns the number of UnitDefinitions in this Model.

=item Model::getNumCompartments

Returns the number of Compartments in this Model.

=item Model::getNumSpecies

Returns the number of Species in this Model.

=item Model::getNumSpeciesWithBoundaryCondition

Returns the number of Species in this Model with boundaryCondition set to true.

=item Model::getNumParameters

Returns the number of Parameters in this Model. Parameters defined in KineticLaws are not included.

=item Model::getNumRules

Returns the number of Rules in this Model.

=item Model::getNumReactions

Returns the number of Reactions in this Model.

=item Model::getNumEvents

Returns the number of Events in this Model.

=item Model::getListOfLayouts

Returns a reference to the ListOf object that holds the layouts.

=item Model::getListOfLayouts

Returns a reference to the ListOf object that holds the layouts.

=item Model::getLayout

Returns the layout object that belongs to the given index. If the index is invalid, NULL is returned.

=item Model::addLayout

Adds the layout object to the list of layouts.

=item Model::createLayout

Creates a new layout object and adds it to the list of layout objects. A reference to the newly created object is returned.

=item SBMLDocument::SBMLDocument

Creates a new SBMLDocument. The SBML level defaults to 2 and version defaults to 1.

=item SBMLDocument::accept

Accepts the given SBMLVisitor.

=item SBMLDocument::createModel

Creates a new Model (optionally with its Id attribute set) inside this SBMLDocument and returns it. This covenience method is equivalent to: setModel( Model() );

=item SBMLDocument::getLevel

Returns the level of this SBMLDocument.

=item SBMLDocument::getVersion

Returns the version of this SBMLDocument.

=item SBMLDocument::getModel

Returns the Model associated with this SBMLDocument.

=item SBMLDocument::getWarning

Returns the nth warning encountered during the parse of this SBMLDocument or NULL if n E<gt> getNumWarnings() - 1.

=item SBMLDocument::getError

Returns the nth error encountered during the parse of this SBMLDocument or NULL if n E<gt> getNumErrors() - 1.

=item SBMLDocument::getFatal

Returns the nth fatal error encountered during the parse of this SBMLDocument or NULL if n E<gt> getNumFatals() - 1.

=item SBMLDocument::getNumWarnings

Returns the number of warnings encountered during the parse of this SBMLDocument.

=item SBMLDocument::getNumErrors

Returns the number of errors encountered during the parse of this SBMLDocument.

=item SBMLDocument::getNumFatals

Returns the number of fatal errors encountered during the parse of this SBMLDocument.

=item SBMLDocument::printWarnings

Prints all warnings encountered during the parse of this SBMLDocument to the given stream. If no warnings have occurred, i.e. getNumWarnings() == 0, no output will be sent to stream. The format of the output is: N Warning(s): line: (id) message

=item SBMLDocument::printErrors

Prints all errors encountered during the parse of this SBMLDocument to the given stream. If no errors have occurred, i.e. getNumErrors() == 0, no output will be sent to stream. The format of the output is: N Error(s): line: (id) message

=item SBMLDocument::printFatals

Prints all fatals encountered during the parse of this SBMLDocument to the given stream. If no fatals have occurred, i.e. getNumFatals() == 0, no output will be sent to stream. The format of the output is: N Fatal(s): line: (id) message

=item SBMLDocument::setLevel

Sets the level of this SBMLDocument to the given level number. Valid levels are currently 1 and 2.

=item SBMLDocument::setVersion

Sets the version of this SBMLDocument to the given version number. Valid versions are currently 1 and 2 for SBML L1 and 1 for SBML L2.

=item SBMLDocument::setModel

Sets the Model of this SBMLDocument to the given Model. Any previously defined model is unset and freed.

=item SBMLDocument::checkConsistency

Performs a set of semantic consistency checks on the document. Query the results by calling getWarning(), getNumError(),and getNumFatal(). Returns the number of failed checks (errors) encountered.

=item SBMLDocument::validate

@deprecated use checkConsistency() instead.

=item SBMLDocument::checkL1Compatibility

Performs a set of semantic consistency checks on the document to establish whether it is compatible with L1 and can be converted. Query the results by calling getWarning(), getNumError(),and getNumFatal(). Returns the number of failed checks (errors) encountered.

=item FunctionDefinition::FunctionDefinition

Creates a new FunctionDefinition, optionally with its id and math attributes set.

=item FunctionDefinition::FunctionDefinition

Creates a new FunctionDefinition, optionally with its id and math attributes set. Creates a new FunctionDefinition, optionally with its id and math (via an infix formula string) attributes set.

=item FunctionDefinition::accept

Accepts the given SBMLVisitor. Returns the result of calling C<v.visit()>, which indicates whether or not the Visitor would like to visit the Model's next FunctionDefinition (if available).

=item FunctionDefinition::getId

Returns the id of this FunctionDefinition.

=item FunctionDefinition::getName

Returns the name of this FunctionDefinition.

=item FunctionDefinition::getMath

Returns the math of this FunctionDefinition.

=item FunctionDefinition::isSetId

Returns true if the id of this FunctionDefinition has been set, false otherwise.

=item FunctionDefinition::isSetName

Returns true if the name of this FunctionDefinition has been set, false otherwise.

=item FunctionDefinition::isSetMath

Returns true if the math of this FunctionDefinition has been set, false otherwise.

=item FunctionDefinition::setId

Sets the id of this FunctionDefinition to a copy of sid.

=item FunctionDefinition::setName

Sets the name of this FunctionDefinition to a copy of string.

=item FunctionDefinition::setMath

Sets the math of this FunctionDefinition to the given ASTNode. The node B<is not copied> and this FunctionDefinition B<takes ownership> of it; i.e. subsequent calls to this function or a call to FunctionDefinition_free() will free the ASTNode (and any child nodes).

=item FunctionDefinition::unsetName

Unsets the name of this FunctionDefinition.

=item Unit::Unit

Creates a new Unit, optionally with its kind, exponent, scale, multiplier, and offset attributes set.

=item Unit::Unit

Creates a new Unit, optionally with its kind (via string), exponent, scale, multiplier, and offset attributes set.

=item Unit::accept

Accepts the given SBMLVisitor. Returns the result of calling C<v.visit()>, which indicates whether or not the Visitor would like to visit the UnitDefinition's next Unit (if available).

=item Unit::initDefaults

Initializes the fields of this Unit to their defaults: - exponent = 1 - scale = 0 - multiplier = 1.0 - offset = 0.0

=item Unit::getKind

Returns the kind of this Unit.

=item Unit::getExponent

Returns the exponent of this Unit.

=item Unit::getScale

Returns the scale of this Unit.

=item Unit::getMultiplier

Returns the multiplier of this Unit.

=item Unit::getOffset

Returns the offset of this Unit.

=item Unit::isAmpere

Returns true if the kind of this Unit is 'ampere', false otherwise.

=item Unit::isBecquerel

Returns true if the kind of this Unit is 'becquerel', false otherwise.

=item Unit::isCandela

Returns true if the kind of this Unit is 'candela', false otherwise.

=item Unit::isCelsius

Returns true if the kind of this Unit is 'Celsius', false otherwise.

=item Unit::isCoulomb

Returns true if the kind of this Unit is 'coulomb', false otherwise.

=item Unit::isDimensionless

Returns true if the kind of this Unit is 'dimensionless', false otherwise.

=item Unit::isFarad

Returns true if the kind of this Unit is 'farad', false otherwise.

=item Unit::isGram

Returns true if the kind of this Unit is 'gram', false otherwise.

=item Unit::isGray

Returns true if the kind of this Unit is 'gray', false otherwise.

=item Unit::isHenry

Returns true if the kind of this Unit is 'henry', false otherwise.

=item Unit::isHertz

Returns true if the kind of this Unit is 'hertz', false otherwise.

=item Unit::isItem

Returns true if the kind of this Unit is 'item', false otherwise.

=item Unit::isJoule

Returns true if the kind of this Unit is 'joule', false otherwise.

=item Unit::isKatal

Returns true if the kind of this Unit is 'katal', false otherwise.

=item Unit::isKelvin

Returns true if the kind of this Unit is 'kelvin', false otherwise.

=item Unit::isKilogram

Returns true if the kind of this Unit is 'kilogram', false otherwise.

=item Unit::isLitre

Returns true if the kind of this Unit is 'litre' or 'liter', false otherwise.

=item Unit::isLumen

Returns true if the kind of this Unit is 'lumen', false otherwise.

=item Unit::isLux

Returns true if the kind of this Unit is 'lux', false otherwise.

=item Unit::isMetre

Returns true if the kind of this Unit is 'metre' or 'meter', false otherwise.

=item Unit::isMole

Returns true if the kind of this Unit is 'mole', false otherwise.

=item Unit::isNewton

Returns true if the kind of this Unit is 'newton', false otherwise.

=item Unit::isOhm

Returns true if the kind of this Unit is 'ohm', false otherwise.

=item Unit::isPascal

Returns true if the kind of this Unit is 'pascal', false otherwise.

=item Unit::isRadian

Returns true if the kind of this Unit is 'radian', false otherwise.

=item Unit::isSecond

Returns true if the kind of this Unit is 'second', false otherwise.

=item Unit::isSiemens

Returns true if the kind of this Unit is 'siemens', false otherwise.

=item Unit::isSievert

Returns true if the kind of this Unit is 'sievert', false otherwise.

=item Unit::isSteradian

Returns true if the kind of this Unit is 'steradian', false otherwise.

=item Unit::isTesla

Returns true if the kind of this Unit is 'tesla', false otherwise.

=item Unit::isVolt

Returns true if the kind of this Unit is 'volt', false otherwise.

=item Unit::isWatt

Returns true if the kind of this Unit is 'watt', false otherwise.

=item Unit::isWeber

Returns true if the kind of this Unit is 'weber', false otherwise.

=item Unit::isSetKind

Returns true if the kind of this Unit has been set, false otherwise.

=item Unit::setKind

Sets the kind of this Unit to the given UnitKind.

=item Unit::setExponent

Sets the exponent of this Unit to the given value.

=item Unit::setScale

Sets the scale of this Unit to the given value.

=item Unit::setMultiplier

Sets the multiplier of this Unit to the given value.

=item Unit::setOffset

Sets the offset of this Unit to the given value.

=item Unit::isBuiltIn

Returns true if name is one of the five SBML builtin Unit names ('substance', 'volume', 'area', 'length' or 'time'), false otherwise.

=item Unit::isUnitKind

Returns true if name is a valid UnitKind.

=item UnitDefinition::UnitDefinition

Creates a new UnitDefinition, optionally with its id and name attributes set.

=item UnitDefinition::accept

Accepts the given SBMLVisitor. Returns the result of calling C<v.visit()>, which indicates whether or not the Visitor would like to visit the Model's next UnitDefinition (if available).

=item UnitDefinition::getId

Returns the id of this UnitDefinition.

=item UnitDefinition::getName

Returns the name of this UnitDefinition.

=item UnitDefinition::isSetId

Returns true if the id of this UnitDefinition has been set, false otherwise.

=item UnitDefinition::isSetName

Returns true if the name of this UnitDefinition has been set, false otherwise. In SBML L1, a UnitDefinition name is required and therefore B<should always be set>. In L2, name is optional and as such may or may not be set.

=item UnitDefinition::isVariantOfArea

Returns true if this UnitDefinition is a variant of the builtin type area, i.e. square metres with only abritrary variations in scale, multiplier, or offset values, false otherwise.

=item UnitDefinition::isVariantOfLength

Returns true if this UnitDefinition is a variant of the builtin type length, i.e. metres with only abritrary variations in scale, multiplier, or offset values, false otherwise.

=item UnitDefinition::isVariantOfSubstance

Returns true if this UnitDefinition is a variant of the builtin type substance, i.e. moles or items with only abritrary variations in scale, multiplier, or offset values, false otherwise.

=item UnitDefinition::isVariantOfTime

Returns true if this UnitDefinition is a variant of the builtin type time, i.e. seconds with only abritrary variations in scale, multiplier, or offset values, false otherwise.

=item UnitDefinition::isVariantOfVolume

Returns true if this UnitDefinition is a variant of the builtin type volume, i.e. litre or cubic metre with only abritrary variations in scale, multiplier, or offset values, false otherwise.

=item UnitDefinition::moveIdToName

Moves the id field of this UnitDefinition to its name field (iff name is not already set). This method is used for converting from L2 to L1.

=item UnitDefinition::moveNameToId

Moves the name field of this UnitDefinition to its id field (iff id is not already set). This method is used for converting from L1 to L2.

=item UnitDefinition::setId

Sets the id of this UnitDefinition to a copy of sid.

=item UnitDefinition::setName

Sets the name of this UnitDefinition to a copy of string (SName in L1).

=item UnitDefinition::unsetName

Unsets the name of this UnitDefinition. In SBML L1, a UnitDefinition name is required and therefore B<should always be set>. In L2, name is optional and as such may or may not be set.

=item UnitDefinition::addUnit

Adds the given Unit to this UnitDefinition.

=item UnitDefinition::getListOfUnits

Returns the list of Units for this UnitDefinition.

=item UnitDefinition::getListOfUnits

Returns the list of Units for this UnitDefinition.

=item UnitDefinition::getUnit

Returns the nth Unit of this UnitDefinition

=item UnitDefinition::getNumUnits

Returns the number of Units in this UnitDefinition.

=item Compartment::Compartment

Creates a new Compartment, optionally with its id attribute set.

=item Compartment::accept

Accepts the given SBMLVisitor. Returns the result of calling C<v.visit()>, which indicates whether or not the Visitor would like to visit the Model's next Compartment (if available).

=item Compartment::initDefaults

Initializes the fields of this Compartment to their defaults: - volume = 1.0 (L1 only) - spatialDimensions = 3 (L2 only) - constant = 1 (true) (L2 only)

=item Compartment::getId

Returns the id of this Compartment.

=item Compartment::getName

Returns the name of this Compartment.

=item Compartment::getSpatialDimensions

Returns the spatialDimensions of this Compartment.

=item Compartment::getSize

Returns the size (volume in L1) of this Compartment.

=item Compartment::getVolume

Returns the volume (size in L2) of this Compartment.

=item Compartment::getUnits

Returns the units of this Compartment.

=item Compartment::getOutside

Returns the outside of this Compartment.

=item Compartment::getConstant

Returns true if this Compartment is constant, false otherwise.

=item Compartment::isSetId

Returns true if the id of this Compartment has been set, false otherwise.

=item Compartment::isSetName

Returns true if the name of this Compartment has been set, false otherwise. In SBML L1, a Compartment name is required and therefore B<should always be set>. In L2, name is optional and as such may or may not be set.

=item Compartment::isSetSize

Returns true if the size (volume in L1) of this Compartment has been set, false otherwise.

=item Compartment::isSetVolume

Returns true if the volume (size in L2) of this Compartment has been set, false otherwise. In SBML L1, a Compartment volume has a default value (1.0) and therefore B<should always be set>. In L2, volume (size) is optional with no default value and as such may or may not be set.

=item Compartment::isSetUnits

Returns true if the units of this Compartment has been set, false otherwise.

=item Compartment::isSetOutside

Returns true if the outside of this Compartment has been set, false otherwise.

=item Compartment::moveIdToName

Moves the id field of this Compartment to its name field (iff name is not already set). This method is used for converting from L2 to L1.

=item Compartment::moveNameToId

Moves the name field of this Compartment to its id field (iff id is not already set). This method is used for converting from L1 to L2.

=item Compartment::setId

Sets the id of this Compartment to a copy of sid.

=item Compartment::setName

Sets the name of this Compartment to a copy of string (SName in L1).

=item Compartment::setSpatialDimensions

Sets the spatialDimensions of this Compartment to value. If value is not one of [0, 1, 2, 3] the function will have no effect (i.e. spatialDimensions will not be set).

=item Compartment::setSize

Sets the size (volume in L1) of this Compartment to value.

=item Compartment::setVolume

Sets the volume (size in L2) of this Compartment to value.

=item Compartment::setUnits

Sets the units of this Compartment to a copy of sid.

=item Compartment::setOutside

Sets the outside of this Compartment to a copy of sid.

=item Compartment::setConstant

Sets the constant field of this Compartment to value.

=item Compartment::unsetName

Unsets the name of this Compartment.

=item Compartment::unsetSize

Unsets the size (volume in L1) of this Compartment.

=item Compartment::unsetVolume

Unsets the volume (size in L2) of this Compartment. In SBML L1, a Compartment volume has a default value (1.0) and therefore B<should always be set>. In L2, volume is optional with no default value and as such may or may not be set.

=item Compartment::unsetUnits

Unsets the units of this Compartment.

=item Compartment::unsetOutside

Unsets the outside of this Compartment.

=item Species::Species

Creates a new Species, optionally with its id attribute set.

=item Species::accept

Accepts the given SBMLVisitor. Returns the result of calling C<v.visit()>, which indicates whether or not the Visitor would like to visit the Model's next Species (if available).

=item Species::initDefaults

Initializes the fields of this Species to their defaults: - boundaryCondition = false - constant = false (L2 only)

=item Species::getId

Returns the id of this Species

=item Species::getName

Returns the name of this Species.

=item Species::getCompartment

Returns the compartment of this Species.

=item Species::getInitialAmount

Returns the initialAmount of this Species.

=item Species::getInitialConcentration

Returns the initialConcentration of this Species.

=item Species::getSubstanceUnits

Returns the substanceUnits of this Species.

=item Species::getSpatialSizeUnits

Returns the spatialSizeUnits of this Species.

=item Species::getUnits

Returns the units of this Species (L1 only).

=item Species::getHasOnlySubstanceUnits

Returns true if this Species hasOnlySubstanceUnits, false otherwise.

=item Species::getBoundaryCondition

Returns the boundaryCondition of this Species.

=item Species::getCharge

Returns the charge of this Species.

=item Species::getConstant

Returns true if this Species is constant, false otherwise.

=item Species::isSetId

Returns true if the id of this Species has been set, false otherwise.

=item Species::isSetName

Returns true if the name of this Species has been set, false otherwise. In SBML L1, a Species name is required and therefore B<should always be set>. In L2, name is optional and as such may or may not be set.

=item Species::isSetCompartment

Returns true if the compartment of this Species has been set, false otherwise.

=item Species::isSetInitialAmount

Returns true if the initialAmount of this Species has been set, false otherwise. In SBML L1, a Species initialAmount is required and therefore B<should always be set>. In L2, initialAmount is optional and as such may or may not be set.

=item Species::isSetInitialConcentration

Returns true if the initialConcentration of this Species has been set, false otherwise.

=item Species::isSetSubstanceUnits

Returns true if the substanceUnits of this Species has been set, false otherwise.

=item Species::isSetSpatialSizeUnits

Returns true if the spatialSizeUnits of this Species has been set, false otherwise.

=item Species::isSetUnits

Returns true if the units of this Species has been set, false otherwise (L1 only).

=item Species::isSetCharge

Returns true if the charge of this Species has been set, false otherwise.

=item Species::moveIdToName

Moves the id field of this Species to its name field (iff name is not already set). This method is used for converting from L2 to L1.

=item Species::moveNameToId

Moves the name field of this Species to its id field (iff id is not already set). This method is used for converting from L1 to L2.

=item Species::setId

Sets the id of this Species to a copy of sid.

=item Species::setName

Sets the name of this Species to a copy of string (SName in L1).

=item Species::setCompartment

Sets the compartment of this Species to a copy of sid.

=item Species::setInitialAmount

Sets the initialAmount of this Species to value and marks the field as set. This method also unsets the initialConentration field.

=item Species::setInitialConcentration

Sets the initialConcentration of this Species to value and marks the field as set. This method also unsets the initialAmount field.

=item Species::setSubstanceUnits

Sets the substanceUnits of this Species to a copy of sid.

=item Species::setSpatialSizeUnits

Sets the spatialSizeUnits of this Species to a copy of sid.

=item Species::setUnits

Sets the units of this Species to a copy of sname (L1 only).

=item Species::setHasOnlySubstanceUnits

Sets the hasOnlySubstanceUnits field of this Species to value.

=item Species::setBoundaryCondition

Sets the boundaryCondition of this Species to value.

=item Species::setCharge

Sets the charge of this Species to value and marks the field as set.

=item Species::setConstant

Sets the constant field of this Species to value.

=item Species::unsetName

Unsets the name of this Species. In SBML L1, a Species name is required and therefore B<should always be set>. In L2, name is optional and as such may or may not be set.

=item Species::unsetInitialAmount

Marks the initialAmount of this Species as unset.

=item Species::unsetInitialConcentration

Unsets the initialConcentration of this Species.

=item Species::unsetSubstanceUnits

Unsets the substanceUnits of this Species.

=item Species::unsetSpatialSizeUnits

Unsets the spatialSizeUnits of this Species.

=item Species::unsetUnits

Unsets the units of this Species (L1 only).

=item Species::unsetCharge

Unsets the charge of this Species.

=item Parameter::Parameter

Creates a new Parameter, optionally with its id attribute set.

=item Parameter::Parameter

Creates a new Parameter, with its id and value attributes set and optionally its units and constant attributes.

=item Parameter::accept

Accepts the given SBMLVisitor. Returns the result of calling C<v.visit()>, which indicates whether or not the Visitor would like to visit the parent Model's or KineticLaw's next Parameter (if available).

=item Parameter::initDefaults

Initializes the fields of this Parameter to their defaults: - constant = true (L2 only)

=item Parameter::getId

Returns the id of this Parameter

=item Parameter::getName

Returns the name of this Parameter.

=item Parameter::getValue

Returns the value of this Parameter.

=item Parameter::getUnits

Returns the units of this Parameter.

=item Parameter::getConstant

Returns true if this Parameter is constant, false otherwise.

=item Parameter::isSetId

Returns true if the id of this Parameter has been set, false otherwise.

=item Parameter::isSetName

Returns true if the name of this Parameter has been set, false otherwise. In SBML L1, a Parameter name is required and therefore B<should always be set>. In L2, name is optional and as such may or may not be set.

=item Parameter::isSetValue

Returns true if the value of this Parameter has been set, false otherwise. In SBML L1v1, a Parameter value is required and therefore B<should always be set>. In L1v2 and beyond, a value is optional and as such may or may not be set.

=item Parameter::isSetUnits

Returns true if the units of this Parameter has been set, false otherwise.

=item Parameter::moveIdToName

Moves the id field of this Parameter to its name field (iff name is not already set). This method is used for converting from L2 to L1.

=item Parameter::moveNameToId

Moves the name field of this Parameter to its id field (iff id is not already set). This method is used for converting from L1 to L2.

=item Parameter::setId

Sets the id of this Parameter to a copy of sid.

=item Parameter::setName

Sets the name of this Parameter to a copy of string (SName in L1).

=item Parameter::setValue

Sets the initialAmount of this Parameter to value and marks the field as set.

=item Parameter::setUnits

Sets the units of this Parameter to a copy of sid.

=item Parameter::setConstant

Sets the constant field of this Parameter to value.

=item Parameter::unsetName

Unsets the name of this Parameter. In SBML L1, a Parameter name is required and therefore B<should always be set>. In L2, name is optional and as such may or may not be set.

=item Parameter::unsetValue

Unsets the value of this Parameter. In SBML L1v1, a Parameter value is required and therefore B<should always be set>. In L1v2 and beyond, a value is optional and as such may or may not be set.

=item Parameter::unsetUnits

Unsets the units of this Parameter.

=item Rule::Rule

Creates a new Rule, optionally with its formula attribute set.

=item Rule::Rule

Creates a new Rule with its math attribute set.

=item Rule::accept

Accepts the given SBMLVisitor. Returns the result of calling C<v.visit()>, which indicates whether or not the Visitor would like to visit the Model's next Rule (if available).

=item Rule::getFormula

Returns the formula for this Rule.

=item Rule::getMath

Returns the math for this Rule.

=item Rule::isSetFormula

Returns true if the formula for this Rule has been set, false otherwise.

=item Rule::isSetMath

Returns true if the math for this Rule has been set, false otherwise.

=item Rule::setFormula

Sets the formula of this Rule to a copy of string.

=item Rule::setFormulaFromMath

Sets the formula of this Rule based on the current value of its math field. This convenience method is equivalent to: setFormula( SBML_formulaToString( getMath() )) except you do not need to track and free the value returned by SBML_formulaToString(). If !isSetMath(r), this method has no effect.

=item Rule::setMath

Sets the math of this Rule to the given ASTNode. The node B<is not copied> and this Rule B<takes ownership> of it; i.e. subsequent calls to this method or deleting this Rule will delete the ASTNode (and any child nodes).

=item Rule::setMathFromFormula

Sets the math of this Rule from its current formula string. This convenience method is equivalent to: setMath( SBML_parseFormula( getFormula() )) If !isSetFormula(), this method has no effect.

=item AlgebraicRule::AlgebraicRule

Creates a new AlgebraicRule, optionally with its formula attribute set.

=item AlgebraicRule::AlgebraicRule

Creates a new AlgebraicRule with its math attribute set.

=item AlgebraicRule::accept

Accepts the given SBMLVisitor. Returns the result of calling C<v.visit()>, which indicates whether or not the Visitor would like to visit the Model's next Rule (if available).

=item AssignmentRule::AssignmentRule

Creates a new AssignmentRule.

=item AssignmentRule::AssignmentRule

Creates a new AssignmentRule with its variable, formula, and (optionally) type attributes set.

=item AssignmentRule::AssignmentRule

Creates a new AssignmentRule with its variable, math and (optionally) type attributes set.

=item AssignmentRule::accept

Accepts the given SBMLVisitor. Returns the result of calling C<v.visit()>, which indicates whether or not the Visitor would like to visit the Model's next Rule (if available).

=item AssignmentRule::initDefaults

The function is kept for backward compatibility with the SBML L1 API. Initializes the fields of this AssignmentRule to their defaults: - type = RULE_TYPE_SCALAR

=item AssignmentRule::getType

Returns the type for this AssignmentRule.

=item AssignmentRule::getVariable

Returns the variable for this AssignmentRule.

=item AssignmentRule::isSetVariable

Returns true if the variable of this AssignmentRule has been set, false otherwise.

=item AssignmentRule::setType

Sets the type of this Rule to the given RuleType.

=item AssignmentRule::setVariable

Sets the variable of this AssignmentRule to a copy of sid.

=item RateRule::RateRule

Creates a new RateRule, optionally with its variable and math (via an infix formula string) attributes set.

=item RateRule::RateRule

Creates a new RateRule with its variable and math attributes set.

=item RateRule::accept

Accepts the given SBMLVisitor. Returns the result of calling C<v.visit()>, which indicates whether or not the Visitor would like to visit the Model's next Rule (if available).

=item RateRule::getVariable

Returns the variable for this RateRule.

=item RateRule::isSetVariable

Returns true if the variable of this RateRule has been set, false otherwise.

=item RateRule::setVariable

Sets the variable of this RateRule to a copy of sid.

=item SpeciesConcentrationRule::SpeciesConcentrationRule

Creates a new SpeciesConcentrationRule.

=item SpeciesConcentrationRule::SpeciesConcentrationRule

Creates a new SpeciesConcentrationRule with its species, formula and (optionally) type attributes set.

=item SpeciesConcentrationRule::accept

Accepts the given SBMLVisitor. Returns the result of calling C<v.visit()>, which indicates whether or not the Visitor would like to visit the Model's next Rule (if available).

=item SpeciesConcentrationRule::getSpecies

Returns the species of this SpeciesConcentrationRule.

=item SpeciesConcentrationRule::isSetSpecies

Returns true if the species of this SpeciesConcentrationRule has been set, false otherwise.

=item SpeciesConcentrationRule::setSpecies

Sets the species of this SpeciesConcentrationRule to a copy of sname.

=item CompartmentVolumeRule::CompartmentVolumeRule

Creates a new CompartmentVolumeRule.

=item CompartmentVolumeRule::CompartmentVolumeRule

Creates a new CompartmentVolumeRule with its compartment, formula and (optionally) type attributes set.

=item CompartmentVolumeRule::accept

Accepts the given SBMLVisitor. Returns the result of calling C<v.visit()>, which indicates whether or not the Visitor would like to visit the Model's next Rule (if available).

=item CompartmentVolumeRule::getCompartment

Returns the compartment of this CompartmentVolumeRule.

=item CompartmentVolumeRule::isSetCompartment

Returns true if the compartment of this CompartmentVolumeRule has been set, false otherwise.

=item CompartmentVolumeRule::setCompartment

Sets the compartment of this CompartmentVolumeRule to a copy of sname.

=item ParameterRule::ParameterRule

Creates a new ParameterRule.

=item ParameterRule::ParameterRule

Creates a new ParameterRule with its name, formula and (optionally) type attributes set.

=item ParameterRule::accept

Accepts the given SBMLVisitor. Returns the result of calling C<v.visit()>, which indicates whether or not the Visitor would like to visit the Model's next Rule (if available).

=item ParameterRule::getName

Returns the (Parameter) name for this ParameterRule.

=item ParameterRule::getUnits

Returns the units for this ParameterRule.

=item ParameterRule::isSetName

Returns true if the (Parameter) name for this ParameterRule has been set, false otherwise.

=item ParameterRule::isSetUnits

Returns true if the units for this ParameterRule has been set, false otherwise.

=item ParameterRule::setName

Sets the (Parameter) name for this ParameterRule to a copy of sname.

=item ParameterRule::setUnits

Sets the units for this ParameterRule to a copy of sname.

=item ParameterRule::unsetUnits

Unsets the units for this ParameterRule.

=item Reaction::Reaction

Creates a new Reaction, optionally with its id, KineticLaw, and reversible attributes set.

=item Reaction::accept

Accepts the given SBMLVisitor. Returns the result of calling C<v.visit()>, which indicates whether or not the Visitor would like to visit the Model's next Reaction (if available).

=item Reaction::initDefaults

Initializes the fields of this Reaction to their defaults: - reversible = true - fast = false (L1 only)

=item Reaction::getId

Returns the id of this Reaction.

=item Reaction::getName

Returns the name of this Reaction.

=item Reaction::getKineticLaw

Returns the KineticLaw of this Reaction.

=item Reaction::getReversible

Returns the reversible status of this Reaction.

=item Reaction::getFast

Returns the fast status of this Reaction.

=item Reaction::isSetId

Returns true if the id of this Reaction has been set, false otherwise.

=item Reaction::isSetName

Returns true if the name of this Reaction has been set, false otherwise. In SBML L1, a Reaction name is required and therefore B<should always be set>. In L2, name is optional and as such may or may not be set.

=item Reaction::isSetKineticLaw

Returns true if the KineticLaw of this Reaction has been set, false otherwise.

=item Reaction::isSetFast

Returns true if the fast status of this Reation has been set, false otherwise. In L1, fast is optional with a default of false, which means it is effectively always set. In L2, however, fast is optional with no default value, so it may or may not be set to a specific value.

=item Reaction::moveIdToName

Moves the id field of this Reaction to its name field (iff name is not already set). This method is used for converting from L2 to L1.

=item Reaction::moveNameToId

Moves the name field of this Reaction to its id field (iff id is not already set). This method is used for converting from L1 to L2.

=item Reaction::setId

Sets the id of this Reaction to a copy of sid.

=item Reaction::setName

Sets the name of this Reaction to a copy of string (SName in L1).

=item Reaction::setKineticLaw

Sets the KineticLaw of this Reaction to the given KineticLaw.

=item Reaction::setReversible

Sets the reversible status of this Reaction to value.

=item Reaction::setFast

Sets the fast status of this Reaction to value.

=item Reaction::addReactant

Adds the given reactant (SpeciesReference) to this Reaction.

=item Reaction::addProduct

Adds the given product (SpeciesReference) to this Reaction.

=item Reaction::addModifier

Adds the given modifier (ModifierSpeciesReference) to this Reaction.

=item Reaction::getListOfReactants

Returns the list of Reactants for this Reaction.

=item Reaction::getListOfReactants

Returns the list of Reactants for this Reaction.

=item Reaction::getListOfProducts

Returns the list of Products for this Reaction.

=item Reaction::getListOfProducts

Returns the list of Products for this Reaction.

=item Reaction::getListOfModifiers

Returns the list of Modifiers for this Reaction.

=item Reaction::getListOfModifiers

Returns the list of Modifiers for this Reaction.

=item Reaction::getReactant

Returns the nth reactant (SpeciesReference) of this Reaction.

=item Reaction::getReactant

Returns the reactant (SpeciesReference) in this Reaction with the given id or NULL if no such reactant exists.

=item Reaction::getProduct

Returns the nth product (SpeciesReference) of this Reaction.

=item Reaction::getProduct

Returns the product (SpeciesReference) in this Reaction with the given id or NULL if no such product exists.

=item Reaction::getModifier

Returns the nth modifier (ModifierSpeciesReference) of this Reaction.

=item Reaction::getModifier

Returns the modifier (ModifierSpeciesReference) in this Reaction with the given id or NULL if no such modifier exists.

=item Reaction::getNumReactants

Returns the number of reactants (SpeciesReferences) in this Reaction.

=item Reaction::getNumProducts

Returns the number of products (SpeciesReferences) in this Reaction.

=item Reaction::getNumModifiers

Returns the number of modifiers (ModifierSpeciesReferences) in this Reaction.

=item Reaction::unsetName

Unsets the name of this Reaction. In SBML L1, a Reaction name is required and therefore B<should always be set>. In L2, name is optional and as such may or may not be set.

=item Reaction::unsetKineticLaw

Unsets the KineticLaw of this Reaction.

=item Reaction::unsetFast

Unsets the fast status of this Reation. In L1, fast is optional with a default of false, which means it is effectively always set. In L2, however, fast is optional with no default value, so it may or may not be set to a specific value.

=item KineticLaw::KineticLaw

Creates a new KineticLaw, optionally with its formula, timeUnits and/or substanceUnits set.

=item KineticLaw::accept

Accepts the given SBMLVisitor.

=item KineticLaw::getFormula

Returns the formula of this KineticLaw.

=item KineticLaw::getMath

Returns the math of this KineticLaw.

=item KineticLaw::getListOfParameters

Returns the list of Parameters for this KineticLaw.

=item KineticLaw::getListOfParameters

Returns the list of Parameters for this KineticLaw.

=item KineticLaw::getTimeUnits

Returns the timeUnits of this KineticLaw.

=item KineticLaw::getSubstanceUnits

Returns the substanceUnits of this KineticLaw.

=item KineticLaw::isSetFormula

Returns true if the formula of this KineticLaw has been set, false otherwise.

=item KineticLaw::isSetMath

Returns true if the math of this KineticLaw has been set, false otherwise.

=item KineticLaw::isSetTimeUnits

Returns true if the timeUnits of this KineticLaw has been set, false otherwise.

=item KineticLaw::isSetSubstanceUnits

Returns true if the substanceUnits of this KineticLaw has been set, false otherwise.

=item KineticLaw::setFormula

Sets the formula of this KineticLaw to a copy of string.

=item KineticLaw::setFormulaFromMath

Sets the formula of this KineticLaw based on the current value of its math field. This convenience method is equivalent to: setFormula( SBML_formulaToString( getMath() )) except you do not need to track and free the value returned by SBML_formulaToString(). If !isSetMath(), this method has no effect.

=item KineticLaw::setMath

Sets the math of this KineticLaw to the given ASTNode. The node B<is not copied> and this KineticLaw B<takes ownership> of it; i.e. subsequent calls to this method or deleting this KineticLaw will delete the ASTNode (and any child nodes).

=item KineticLaw::setMathFromFormula

Sets the math of this KineticLaw from its current formula string. This convenience method is equivalent to: setMath( SBML_parseFormula( getFormula() )) If !isSetFormula(), this method has no effect.

=item KineticLaw::setTimeUnits

Sets the timeUnits of this KineticLaw to a copy of sname.

=item KineticLaw::setSubstanceUnits

Sets the substanceUnits of this KineticLaw to a copy of sname.

=item KineticLaw::addParameter

Adds the given Parameter to this KineticLaw.

=item KineticLaw::getParameter

Returns the nth Parameter of this KineticLaw.

=item KineticLaw::getNumParameters

Returns the number of Parameters in this KineticLaw.

=item KineticLaw::unsetTimeUnits

Unsets the timeUnits of this KineticLaw.

=item KineticLaw::unsetSubstanceUnits

Unsets the substanceUnits of this KineticLaw.

=item SimpleSpeciesReference::SimpleSpeciesReference

Creates a new SimpleSpeciesReference, optionally with its species attribute set.

=item SimpleSpeciesReference::accept

Accepts the given SBMLVisitor. Returns the result of calling C<v.visit()>, which indicates whether or not the Visitor would like to visit the Reaction's next SimpleSpeciesReference (if available).

=item SimpleSpeciesReference::getSpecies

Returns the species for this SimpleSpeciesReference.

=item SimpleSpeciesReference::isSetSpecies

Returns true if the species for this SimpleSpeciesReference has been set, false otherwise.

=item SimpleSpeciesReference::setSpecies

Sets the species of this SimpleSpeciesReference to a copy of sid.

=item SimpleSpeciesReference::setId

Sets the id for the species reference.

=item SimpleSpeciesReference::getId

Returns the id for the species reference.

=item SimpleSpeciesReference::isSetId

Returns true if the id of the species reference is not equal to the empty string.

=item SimpleSpeciesReference::unsetId

Unsets the id for the species reference.

=item SimpleSpeciesReferenceCmp

The SimpleSpeciesReferenceCmp function compares the string sid to ssr->species. Returnss an integer less than, equal to, or greater than zero if sid is found to be, respectively, less than, to match or be greater than ssr->species. Returns -1 if either sid or ssr->species is NULL.

=item SpeciesReference::SpeciesReference

Creates a new SpeciesReference, optionally with its species, stoichiometry, and denominator attributes set.

=item SpeciesReference::accept

Accepts the given SBMLVisitor. Returns the result of calling C<v.visit()>, which indicates whether or not the Visitor would like to visit the Reaction's next SimpleSpeciesReference (if available).

=item SpeciesReference::initDefaults

Initializes the fields of this SpeciesReference to their defaults: - stoichiometry = 1 - denominator = 1

=item SpeciesReference::getStoichiometry

Returns the stoichiometry of this SpeciesReference.

=item SpeciesReference::getStoichiometryMath

Returns the stoichiometryMath of this SpeciesReference.

=item SpeciesReference::getDenominator

Returns the denominator of this SpeciesReference.

=item SpeciesReference::isSetStoichiometryMath

Returns true if the stoichiometryMath of this SpeciesReference has been set, false otherwise.

=item SpeciesReference::setStoichiometry

Sets the stoichiometry of this SpeciesReference to value.

=item SpeciesReference::setStoichiometryMath

Sets the stoichiometryMath of this SpeciesReference to the given ASTNode. The node B<is not copied> and this SpeciesReference B<takes ownership> of it; i.e. subsequent calls to this function or a call to SpeciesReference_free() will free the ASTNode (and any child nodes).

=item SpeciesReference::setStoichiometryMath

Sets the stoichiometryMath of this SpeciesReference to the given formula string.

=item SpeciesReference::setDenominator

Sets the denominator of this SpeciesReference to value.

=item ModifierSpeciesReference::ModifierSpeciesReference

Creates a new ModifierSpeciesReference, optionally with its species attribute set.

=item ModifierSpeciesReference::accept

Accepts the given SBMLVisitor. Returns the result of calling C<v.visit()>, which indicates whether or not the Visitor would like to visit the Reaction's next SimpleSpeciesReference (if available).

=item Event::Event

Creates a new Event, optionally with its id, trigger and delay attribute set. Trigger and delay may be specified as infix formula strings.

=item Event::Event

Creates a new Event with an id and trigger and (optionally) delay attributes set.

=item Event::accept

Accepts the given SBMLVisitor. Returns the result of calling C<v.visit()>, which indicates whether or not the Visitor would like to visit the Model's next Event (if available).

=item Event::getId

Returns the id of this Event.

=item Event::getName

Returns the name of this Event.

=item Event::getTrigger

Returns the trigger of this Event.

=item Event::getDelay

Returns the delay of this Event.

=item Event::getTimeUnits

Returns the timeUnits of this Event.

=item Event::isSetId

Returns true if the id of this Event has been set, false otherwise.

=item Event::isSetName

Returns true if the name of this Event has been set, false otherwise.

=item Event::isSetTrigger

Returns true if the trigger of this Event has been set, false otherwise.

=item Event::isSetDelay

Returns true if the delay of this Event has been set, false otherwise.

=item Event::isSetTimeUnits

Returns true if the timeUnits of this Event has been set, false otherwise.

=item Event::setId

Sets the id of this Event to a copy of sid.

=item Event::setName

Sets the name of this Event to a copy of string.

=item Event::setTrigger

Sets the trigger of this Event to the given ASTNode. The node B<is not copied> and this Event B<takes ownership> of it; i.e. subsequent calls to this function or a call to Event_free() will free the ASTNode (and any child nodes).

=item Event::setDelay

Sets the delay of this Event to the given ASTNode. The node B<is not copied> and this Event B<takes ownership> of it; i.e. subsequent calls to this function or a call to Event_free() will free the ASTNode (and any child nodes).

=item Event::setTimeUnits

Sets the timeUnits of this Event to a copy of sid.

=item Event::unsetId

Unsets the id of this Event.

=item Event::unsetName

Unsets the name of this Event.

=item Event::unsetDelay

Unsets the delay of this Event.

=item Event::unsetTimeUnits

Unsets the timeUnits of this Event.

=item Event::addEventAssignment

Appends the given EventAssignment to this Event.

=item Event::getListOfEventAssignments

Returns the list of EventAssignments for this Event.

=item Event::getListOfEventAssignments

Returns the list of EventAssignments for this Event.

=item Event::getEventAssignment

Returns the nth EventAssignment of this Event.

=item Event::getNumEventAssignments

Returns the number of EventAssignments in this Event.

=item EventAssignment::EventAssignment

Creates a new EventAssignment, optionally with its variable and math (via infix formula string) attributes set.

=item EventAssignment::EventAssignment

Creates a new EventAssignment, optionally with its variable and math (via infix formula string) attributes set. Creates a new EventAssignment with its variable and math attributes set.

=item EventAssignment::accept

Accepts the given SBMLVisitor. Returns the result of calling C<v.visit()>, which indicates whether or not the Visitor would like to visit the Event's next EventAssignment (if available).

=item EventAssignment::getVariable

Returns the variable of this EventAssignment.

=item EventAssignment::getMath

Returns the math of this EventAssignment.

=item EventAssignment::isSetVariable

Returns true if the variable of this EventAssignment has been set, false otherwise.

=item EventAssignment::isSetMath

Returns true if the math of this EventAssignment has been set, false otherwise.

=item EventAssignment::setVariable

Sets the variable of this EventAssignment to a copy of sid.

=item EventAssignment::setMath

Sets the math of this EventAssignment to the given ASTNode. The node B<is not copied> and this EventAssignment B<takes ownership> of it; i.e. subsequent calls to this function or a call to EventAssignment_free() will free the ASTNode (and any child nodes).

=item UnitKind_equals

Tests for logical equality between two UnitKinds. This function behaves exactly like C's == operator, except for the following two cases: - UNIT_KIND_LITER == UNIT_KIND_LITRE - UNIT_KIND_METER == UNIT_KIND_METRE where C would yield false (since each of the above is a distinct enumeration value), UnitKind_equals(...) yields true. Returns true (!0) if uk1 is logically equivalent to uk2, false (0) otherwise.

=item UnitKind_forName

Returns the UnitKind with the given name (case-insensitive).

=item UnitKind_toString

Returns the name of the given UnitKind. The caller does not own the returned string and is therefore not allowed to modify it.

=item UnitKind_isValidUnitKindString

Returns nonzero if string is the name of a valid unitKind.

=item RuleType_forName

Returns the RuleType with the given name (case-insensitive).

=item RuleType_toString

Returns the name of the given RuleType. The caller does not own the returned string and is therefore not allowed to modify it.

=item readMathMLFromString

Reads the MathML from the given XML string, constructs a corresponding abstract syntax tree and returns a pointer to the root of the tree.

=item MathMLWriter::MathMLWriter

Creates a new MathMLWriter.

=item MathMLWriter::write

Writes the given MathML document to filename. Returns true on success and false if the filename could not be opened for writing.

=item MathMLWriter::write

Writes the given MathML document to the output stream. Returns true on success and false if one of the underlying Xerces or Expat components fail (rare).

=item MathMLWriter::writeToString

Writes the given MathML document to an in-memory string and returns a pointer to it. The string is owned by the caller and should be freed (with free()) when no longer needed. Returns the string on success and 0 if one of the underlying Xerces or Expat components fail (rare).

=item writeMathML

Writes the given MathML document to filename. Returns true on success and false if the filename could not be opened for writing.

=item writeMathMLToString

Writes the given MathML document to an in-memory string and returns a pointer to it. The string is owned by the caller and should be freed (with free()) when no longer needed. Returns the string on success and 0 if one of the underlying Xerces or Expat components fail (rare).

=item ASTNode::ASTNode

Creates a new ASTNode. By default, node will have a type of AST_UNKNOWN and should be set to something else as soon as possible.

=item ASTNode::canonicalize

Attempts to convert this ASTNode to a canonical form and returns true if the conversion succeeded, false otherwise. The rules determining the canonical form conversion are as follows: 1. If the node type is AST_NAME and the node name matches 'ExponentialE', 'Pi', 'True' or 'False' the node type is converted to the corresponding AST_CONSTANT type. 2. If the node type is an AST_FUNCTION and the node name matches an L1 or L2 (MathML) function name, logical operator name, or relational operator name, the node is converted to the correspnding AST_FUNCTION, AST_LOGICAL or AST_CONSTANT type. L1 function names are searched first, so canonicalizing 'log' will result in a node type of AST_FUNCTION_LN (see L1 Specification, Appendix C). Some canonicalizations result in a structural converion of the nodes (by adding a child). For example, a node with L1 function name 'sqr' and a single child node (the argument) will be transformed to a node of type AST_FUNCTION_POWER with two children. The first child will remain unchanged, but the second child will be an ASTNode of type AST_INTEGER and a value of 2. The function names that result in structural changes are: log10, sqr and sqrt.

=item ASTNode::addChild

Adds the given node as a child of this ASTNode. Child nodes are added in-order from 'left-to-right'.

=item ASTNode::prependChild

Adds the given node as a child of this ASTNode. This method adds child nodes from 'right-to-left'.

=item ASTNode::getChild

Returns the nth child of this ASTNode or NULL if this node has no nth child (n E<gt> ASTNode_getNumChildren() - 1).

=item ASTNode::getLeftChild

Returns the left child of this ASTNode. This is equivalent to getChild(0);

=item ASTNode::getRightChild

Returns the right child of this ASTNode or NULL if this node has no right child. If getNumChildren() E<gt> 1, then this is equivalent to: getChild( getNumChildren() - 1);

=item ASTNode::getNumChildren

Returns the number of children of this ASTNode or 0 is this node has no children.

=item ASTNode::getListOfNodes

Performs a depth-first search (DFS) of the tree rooted at node and returns the List of nodes where predicate(node) returns true. The typedef for ASTNodePredicate is: int (ASTNodePredicate) (const ASTNode_t node); where a return value of non-zero represents true and zero represents false. The List returned is owned by the caller and should be deleted. The ASTNodes in the list, however, are not owned by the caller (as they still belong to the tree itself) and therefore should not be deleted.

=item ASTNode::fillListOfNodes

This method is identical in functionality to getListOfNodes(), except the List is passed-in by the caller.

=item ASTNode::getCharacter

Returns the value of this ASTNode as a single character. This function should be called only when getType() is one of AST_PLUS, AST_MINUS, AST_TIMES, AST_DIVIDE or AST_POWER.

=item ASTNode::getInteger

Returns the value of this ASTNode as a (long) integer. This function should be called only when getType() == AST_INTEGER.

=item ASTNode::getName

Returns the value of this ASTNode as a string. This function may be called on nodes that are not operators (isOperator() == false) or numbers (isNumber() == false).

=item ASTNode::getNumerator

Returns the value of the numerator of this ASTNode. This function should be called only when getType() == AST_RATIONAL.

=item ASTNode::getDenominator

Returns the value of the denominator of this ASTNode. This function should be called only when getType() == AST_RATIONAL.

=item ASTNode::getReal

Returns the value of this ASTNode as a real (double). This function should be called only when isReal() == true. This function performs the necessary arithmetic if the node type is AST_REAL_E (mantissa $10^exponent$) or AST_RATIONAL (numerator / denominator).

=item ASTNode::getMantissa

Returns the value of the mantissa of this ASTNode. This function should be called only when getType() is AST_REAL_E or AST_REAL. If AST_REAL, this method is identical to getReal().

=item ASTNode::getExponent

Returns the value of the exponent of this ASTNode. This function should be called only when getType() is AST_REAL_E or AST_REAL.

=item ASTNode::getPrecedence

Returns the precedence of this ASTNode (as defined in the SBML L1 specification).

=item ASTNode::getType

Returns the type of this ASTNode.

=item ASTNode::isBoolean

Returns true if this ASTNode is a boolean (a logical operator, a relational operator, or the constants true or false), false otherwise.

=item ASTNode::isConstant

Returns true if this ASTNode is a MathML constant (true, false, pi, exponentiale), false otherwise.

=item ASTNode::isFunction

Returns true if this ASTNode is a function in SBML L1, L2 (MathML) (everything from abs() to tanh()) or user-defined, false otherwise.

=item ASTNode::isInteger

Returns true if this ASTNode is of type AST_INTEGER, false otherwise.

=item ASTNode::isLambda

Returns true if this ASTNode is of type AST_LAMBDA, false otherwise.

=item ASTNode::isLog10

Returns true if the given ASTNode represents a log10() function, false otherwise. More precisley, the node type is AST_FUNCTION_LOG with two children the first of which is an AST_INTEGER equal to 10.

=item ASTNode::isLogical

Returns true if this ASTNode is a MathML logical operator (and, or, not, xor), false otherwise.

=item ASTNode::isName

Returns true if this ASTNode is a user-defined variable name in SBML L1, L2 (MathML) or the special symbols delay or time, false otherwise.

=item ASTNode::isNumber

Returns true if this ASTNode is a number, false otherwise. This is functionally equivalent to: isInteger() || isReal().

=item ASTNode::isOperator

Returns true if this ASTNode is an operator, false otherwise. Operators are: +, -, , / and \^ (power).

=item ASTNode::isRational

Returns true if this ASTNode is of type AST_RATIONAL, false otherwise.

=item ASTNode::isReal

Returns true if the value of this ASTNode can represented as a real number, false otherwise. To be a represented as a real number, this node must be of one of the following types: AST_REAL, AST_REAL_E or AST_RATIONAL.

=item ASTNode::isRelational

Returns true if this ASTNode is a MathML relational operator (==, >=, >, <=, E<lt> !=), false otherwise.

=item ASTNode::isSqrt

Returns true if the given ASTNode represents a sqrt() function, false otherwise. More precisley, the node type is AST_FUNCTION_ROOT with two children the first of which is an AST_INTEGER equal to 2.

=item ASTNode::isUMinus

Returns true if this ASTNode is a unary minus, false otherwise. For numbers, unary minus nodes can be 'collapsed' by negating the number. In fact, SBML_parseFormula() does this during its parse. However, unary minus nodes for symbols (AST_NAMES) cannot be 'collapsed', so this predicate function is necessary. A node is defined as a unary minus node if it is of type AST_MINUS and has exactly one child.

=item ASTNode::isUnknown

Returns true if this ASTNode is of type AST_UNKNOWN, false otherwise.

=item ASTNode::setCharacter

Sets the value of this ASTNode to the given character. If character is one of '+', '-', '', '/' or '\^', the node type will be set accordingly. For all other characters, the node type will be set to AST_UNKNOWN.

=item ASTNode::setName

Sets the value of this ASTNode to the given name. The node type will be set (to AST_NAME) ONLY IF the ASTNode was previously an operator (isOperator(node) == true) or number (isNumber(node) == true). This allows names to be set for AST_FUNCTIONs and the like.

=item ASTNode::setValue

Sets the value of this ASTNode to the given integer and sets the node type to AST_INTEGER.

=item ASTNode::setValue

Sets the value of this ASTNode to the given (long) integer and sets the node type to AST_INTEGER.

=item ASTNode::setValue

Sets the value of this ASTNode to the given rational in two parts: the numerator and denominator. The node type is set to AST_RATIONAL.

=item ASTNode::setValue

Sets the value of this ASTNode to the given real (double) and sets the node type to AST_REAL. This is functionally equivalent to: setValue(value, 0);

=item ASTNode::setValue

Sets the value of this ASTNode to the given real (double) in two parts: the mantissa and the exponent. The node type is set to AST_REAL_E.

=item ASTNode::setType

Sets the type of this ASTNode to the given ASTNodeType.

=item SBML_parseFormula

Parses the given SBML formula and returns a representation of it as an Abstract Syntax Tree (AST). The root node of the AST is returned. If the formula contains a grammatical error, NULL is returned.

=item MathMLDocument::MathMLDocument

Creates a new MathMLDocument.

=item MathMLDocument::getMath

Returns the an abstract syntax tree (AST) representation of the math in this MathMLDocument.

=item MathMLDocument::isSetMath

Returns true if the math of this MathMLDocument has been set, false otherwise.

=item MathMLDocument::setMath

Sets the math of this MathMLDocument to the given ASTNode. The node B<is not copied> and this MathMLDocument B<takes ownership> of it; i.e. subsequent calls to this function or a call to MathMLDocument_free() will free the ASTNode (and any child nodes).

=item ParseMessage::ParseMessage

Creates a new ParseMessage reporting that message occurred at the given line and column. Each ParseMessage has an identification number associated with it.

=item ParseMessage::ParseMessage

Creates a new ParseMessage by copying an existing ParseMessage.

=item ParseMessage::getId

Returns the id of this ParseMessage.

=item ParseMessage::getMessage

Returns the message text of this ParseMessage.

=item ParseMessage::getLine

Returns the line number where this ParseMessage ocurred.

=item ParseMessage::getColumn

Returns the column number where this ParseMessage occurred.

=item XMLNamespace::XMLNamespace

Creates a new XMLNamespace with prefix and URI. If prefix starts with 'xmlns:' (case-insensitive), it will be removed.

=item XMLNamespace::startsWithXMLNS

Returns true if prefix begins with 'xmlns:' (case-insensitive), false otherwise.

=item XMLNamespaceList::add

Adds XMLNamespace to this list of XML namespaces.

=item XMLNamespaceList::add

Adds (prefix, URI) to this list of XML namespaces. If prefix starts with 'xmlns:' (case-insensitive), it will be removed.

=item XMLNamespaceList::getLength

Returns the number of XML namespaces in this list.

=item XMLNamespaceList::getNamespace

Returns the nth XMLNamespace in this list.

=item XMLNamespaceList::getPrefix

Returns the prefix of the nth XML namespace in this list.

=item XMLNamespaceList::getPrefix

Returns the prefix of the XML namespace with the given URI. If URI is not in this list of namespaces, an empty string is returned.

=item XMLNamespaceList::getURI

Returns the URI of the nth XML namespace in this list.

=item XMLNamespaceList::getURI

Returns the URI of the XML namespace with the given prefix. If prefix was not found, an empty string is returned.

=cut

# ---------- BASE METHODS -------------

package LibSBML;

sub TIEHASH {
    my ($classname,$obj) = @_;
    return bless $obj, $classname;
}

sub CLEAR { }

sub FIRSTKEY { }

sub NEXTKEY { }

sub FETCH {
    my ($self,$field) = @_;
    my $member_func = "swig_${field}_get";
    $self->$member_func();
}

sub STORE {
    my ($self,$field,$newval) = @_;
    my $member_func = "swig_${field}_set";
    $self->$member_func($newval);
}

sub this {
    my $ptr = shift;
    return tied(%$ptr);
}


# ------- FUNCTION WRAPPERS --------

package LibSBML;

*printFatals = *LibSBMLc::printFatals;
*printErrors = *LibSBMLc::printErrors;
*printWarnings = *LibSBMLc::printWarnings;
*readSBML = *LibSBMLc::readSBML;
*readSBMLFromString = *LibSBMLc::readSBMLFromString;
*writeSBML = *LibSBMLc::writeSBML;
*writeSBMLToString = *LibSBMLc::writeSBMLToString;
*SBMLTypeCode_toString = *LibSBMLc::SBMLTypeCode_toString;
*SBaseTest_setup = *LibSBMLc::SBaseTest_setup;
*UnitKind_equals = *LibSBMLc::UnitKind_equals;
*UnitKind_forName = *LibSBMLc::UnitKind_forName;
*UnitKind_toString = *LibSBMLc::UnitKind_toString;
*UnitKind_isValidUnitKindString = *LibSBMLc::UnitKind_isValidUnitKindString;
*RuleType_forName = *LibSBMLc::RuleType_forName;
*RuleType_toString = *LibSBMLc::RuleType_toString;
*readMathMLFromString = *LibSBMLc::readMathMLFromString;
*writeMathML = *LibSBMLc::writeMathML;
*writeMathMLToString = *LibSBMLc::writeMathMLToString;
*parseFormula = *LibSBMLc::parseFormula;
*formulaToString = *LibSBMLc::formulaToString;

############# Class : LibSBML::SBMLReader ##############

package LibSBML::SBMLReader;
@ISA = qw( LibSBML );
%OWNER = ();
%ITERATORS = ();
sub new {
    my $pkg = shift;
    my $self = LibSBMLc::new_SBMLReader(@_);
    bless $self, $pkg if defined($self);
}

sub DESTROY {
    return unless $_[0]->isa('HASH');
    my $self = tied(%{$_[0]});
    return unless defined $self;
    delete $ITERATORS{$self};
    if (exists $OWNER{$self}) {
        LibSBMLc::delete_SBMLReader($self);
        delete $OWNER{$self};
    }
}

*getSchemaFilenameL1v1 = *LibSBMLc::SBMLReader_getSchemaFilenameL1v1;
*getSchemaFilenameL1v2 = *LibSBMLc::SBMLReader_getSchemaFilenameL1v2;
*getSchemaFilenameL2v1 = *LibSBMLc::SBMLReader_getSchemaFilenameL2v1;
*getSchemaValidationLevel = *LibSBMLc::SBMLReader_getSchemaValidationLevel;
*readSBML = *LibSBMLc::SBMLReader_readSBML;
*readSBMLFromString = *LibSBMLc::SBMLReader_readSBMLFromString;
*setSchemaFilenameL1v1 = *LibSBMLc::SBMLReader_setSchemaFilenameL1v1;
*setSchemaFilenameL1v2 = *LibSBMLc::SBMLReader_setSchemaFilenameL1v2;
*setSchemaFilenameL2v1 = *LibSBMLc::SBMLReader_setSchemaFilenameL2v1;
*setSchemaValidationLevel = *LibSBMLc::SBMLReader_setSchemaValidationLevel;
sub DISOWN {
    my $self = shift;
    my $ptr = tied(%$self);
    delete $OWNER{$ptr};
}

sub ACQUIRE {
    my $self = shift;
    my $ptr = tied(%$self);
    $OWNER{$ptr} = 1;
}


############# Class : LibSBML::SBMLWriter ##############

package LibSBML::SBMLWriter;
@ISA = qw( LibSBML );
%OWNER = ();
%ITERATORS = ();
sub new {
    my $pkg = shift;
    my $self = LibSBMLc::new_SBMLWriter(@_);
    bless $self, $pkg if defined($self);
}

sub DESTROY {
    return unless $_[0]->isa('HASH');
    my $self = tied(%{$_[0]});
    return unless defined $self;
    delete $ITERATORS{$self};
    if (exists $OWNER{$self}) {
        LibSBMLc::delete_SBMLWriter($self);
        delete $OWNER{$self};
    }
}

*setProgramName = *LibSBMLc::SBMLWriter_setProgramName;
*setProgramVersion = *LibSBMLc::SBMLWriter_setProgramVersion;
*write = *LibSBMLc::SBMLWriter_write;
*writeToString = *LibSBMLc::SBMLWriter_writeToString;
sub DISOWN {
    my $self = shift;
    my $ptr = tied(%$self);
    delete $OWNER{$ptr};
}

sub ACQUIRE {
    my $self = shift;
    my $ptr = tied(%$self);
    $OWNER{$ptr} = 1;
}


############# Class : LibSBML::SBase ##############

package LibSBML::SBase;
@ISA = qw( LibSBML );
%OWNER = ();
%ITERATORS = ();
sub DESTROY {
    return unless $_[0]->isa('HASH');
    my $self = tied(%{$_[0]});
    return unless defined $self;
    delete $ITERATORS{$self};
    if (exists $OWNER{$self}) {
        LibSBMLc::delete_SBase($self);
        delete $OWNER{$self};
    }
}

*init = *LibSBMLc::SBase_init;
*getTypeCode = *LibSBMLc::SBase_getTypeCode;
*getColumn = *LibSBMLc::SBase_getColumn;
*getLine = *LibSBMLc::SBase_getLine;
*getMetaId = *LibSBMLc::SBase_getMetaId;
*getNotes = *LibSBMLc::SBase_getNotes;
*getAnnotation = *LibSBMLc::SBase_getAnnotation;
*getNamespaces = *LibSBMLc::SBase_getNamespaces;
*hasNamespaces = *LibSBMLc::SBase_hasNamespaces;
*isSetMetaId = *LibSBMLc::SBase_isSetMetaId;
*isSetNotes = *LibSBMLc::SBase_isSetNotes;
*isSetAnnotation = *LibSBMLc::SBase_isSetAnnotation;
*setMetaId = *LibSBMLc::SBase_setMetaId;
*setNotes = *LibSBMLc::SBase_setNotes;
*setAnnotation = *LibSBMLc::SBase_setAnnotation;
*toSBML = *LibSBMLc::SBase_toSBML;
*unsetMetaId = *LibSBMLc::SBase_unsetMetaId;
*unsetNotes = *LibSBMLc::SBase_unsetNotes;
*unsetAnnotation = *LibSBMLc::SBase_unsetAnnotation;
sub DISOWN {
    my $self = shift;
    my $ptr = tied(%$self);
    delete $OWNER{$ptr};
}

sub ACQUIRE {
    my $self = shift;
    my $ptr = tied(%$self);
    $OWNER{$ptr} = 1;
}


############# Class : LibSBML::ListOf ##############

package LibSBML::ListOf;
@ISA = qw( LibSBML LibSBML::SBase );
%OWNER = ();
%ITERATORS = ();
sub new {
    my $pkg = shift;
    my $self = LibSBMLc::new_ListOf(@_);
    bless $self, $pkg if defined($self);
}

sub DESTROY {
    return unless $_[0]->isa('HASH');
    my $self = tied(%{$_[0]});
    return unless defined $self;
    delete $ITERATORS{$self};
    if (exists $OWNER{$self}) {
        LibSBMLc::delete_ListOf($self);
        delete $OWNER{$self};
    }
}

sub append {
  $_[1]->DISOWN() if defined $_[1];
  return LibSBMLc::ListOf_append(@_);
}

*get = *LibSBMLc::ListOf_get;
*getNumItems = *LibSBMLc::ListOf_getNumItems;
sub prepend {
  $_[1]->DISOWN() if defined $_[1];
  return LibSBMLc::ListOf_prepend(@_);
}

sub remove {
  my $obj = LibSBMLc::ListOf_remove(@_);
  $obj->DISOWN() if defined $obj;
  return $obj;
}

sub DISOWN {
    my $self = shift;
    my $ptr = tied(%$self);
    delete $OWNER{$ptr};
}

sub ACQUIRE {
    my $self = shift;
    my $ptr = tied(%$self);
    $OWNER{$ptr} = 1;
}


############# Class : LibSBML::Model ##############

package LibSBML::Model;
@ISA = qw( LibSBML LibSBML::SBase );
%OWNER = ();
%ITERATORS = ();
sub new {
    my $pkg = shift;
    my $self = LibSBMLc::new_Model(@_);
    bless $self, $pkg if defined($self);
}

sub DESTROY {
    return unless $_[0]->isa('HASH');
    my $self = tied(%{$_[0]});
    return unless defined $self;
    delete $ITERATORS{$self};
    if (exists $OWNER{$self}) {
        LibSBMLc::delete_Model($self);
        delete $OWNER{$self};
    }
}

*getId = *LibSBMLc::Model_getId;
*getName = *LibSBMLc::Model_getName;
*isSetId = *LibSBMLc::Model_isSetId;
*isSetName = *LibSBMLc::Model_isSetName;
*moveAllIdsToNames = *LibSBMLc::Model_moveAllIdsToNames;
*moveAllNamesToIds = *LibSBMLc::Model_moveAllNamesToIds;
*moveIdToName = *LibSBMLc::Model_moveIdToName;
*moveNameToId = *LibSBMLc::Model_moveNameToId;
*setId = *LibSBMLc::Model_setId;
*setName = *LibSBMLc::Model_setName;
*unsetId = *LibSBMLc::Model_unsetId;
*unsetName = *LibSBMLc::Model_unsetName;
*createFunctionDefinition = *LibSBMLc::Model_createFunctionDefinition;
*createUnitDefinition = *LibSBMLc::Model_createUnitDefinition;
*createUnit = *LibSBMLc::Model_createUnit;
*createCompartment = *LibSBMLc::Model_createCompartment;
*createSpecies = *LibSBMLc::Model_createSpecies;
*createParameter = *LibSBMLc::Model_createParameter;
*createAssignmentRule = *LibSBMLc::Model_createAssignmentRule;
*createRateRule = *LibSBMLc::Model_createRateRule;
*createAlgebraicRule = *LibSBMLc::Model_createAlgebraicRule;
*createCompartmentVolumeRule = *LibSBMLc::Model_createCompartmentVolumeRule;
*createParameterRule = *LibSBMLc::Model_createParameterRule;
*createSpeciesConcentrationRule = *LibSBMLc::Model_createSpeciesConcentrationRule;
*createReaction = *LibSBMLc::Model_createReaction;
*createReactant = *LibSBMLc::Model_createReactant;
*createProduct = *LibSBMLc::Model_createProduct;
*createModifier = *LibSBMLc::Model_createModifier;
*createKineticLaw = *LibSBMLc::Model_createKineticLaw;
*createKineticLawParameter = *LibSBMLc::Model_createKineticLawParameter;
*createEvent = *LibSBMLc::Model_createEvent;
*createEventAssignment = *LibSBMLc::Model_createEventAssignment;
sub addFunctionDefinition {
  $_[1]->DISOWN() if defined $_[1];
  return LibSBMLc::Model_addFunctionDefinition(@_);
}

sub addUnitDefinition {
  $_[1]->DISOWN() if defined $_[1];
  return LibSBMLc::Model_addUnitDefinition(@_);
}

sub addCompartment {
  $_[1]->DISOWN() if defined $_[1];
  return LibSBMLc::Model_addCompartment(@_);
}

sub addSpecies {
  $_[1]->DISOWN() if defined $_[1];
  return LibSBMLc::Model_addSpecies(@_);
}

sub addParameter {
  $_[1]->DISOWN() if defined $_[1];
  return LibSBMLc::Model_addParameter(@_);
}

sub addRule {
  $_[1]->DISOWN() if defined $_[1];
  return LibSBMLc::Model_addRule(@_);
}

sub addReaction {
  $_[1]->DISOWN() if defined $_[1];
  return LibSBMLc::Model_addReaction(@_);
}

sub addEvent {
  $_[1]->DISOWN() if defined $_[1];
  return LibSBMLc::Model_addEvent(@_);
}

*getListOfFunctionDefinitions = *LibSBMLc::Model_getListOfFunctionDefinitions;
*getListOfUnitDefinitions = *LibSBMLc::Model_getListOfUnitDefinitions;
*getListOfCompartments = *LibSBMLc::Model_getListOfCompartments;
*getListOfSpecies = *LibSBMLc::Model_getListOfSpecies;
*getListOfParameters = *LibSBMLc::Model_getListOfParameters;
*getListOfRules = *LibSBMLc::Model_getListOfRules;
*getListOfReactions = *LibSBMLc::Model_getListOfReactions;
*getListOfEvents = *LibSBMLc::Model_getListOfEvents;
*getFunctionDefinition = *LibSBMLc::Model_getFunctionDefinition;
*getUnitDefinition = *LibSBMLc::Model_getUnitDefinition;
*getCompartment = *LibSBMLc::Model_getCompartment;
*getSpecies = *LibSBMLc::Model_getSpecies;
*getParameter = *LibSBMLc::Model_getParameter;
*getRule = *LibSBMLc::Model_getRule;
*getReaction = *LibSBMLc::Model_getReaction;
*getEvent = *LibSBMLc::Model_getEvent;
*getNumFunctionDefinitions = *LibSBMLc::Model_getNumFunctionDefinitions;
*getNumUnitDefinitions = *LibSBMLc::Model_getNumUnitDefinitions;
*getNumCompartments = *LibSBMLc::Model_getNumCompartments;
*getNumSpecies = *LibSBMLc::Model_getNumSpecies;
*getNumSpeciesWithBoundaryCondition = *LibSBMLc::Model_getNumSpeciesWithBoundaryCondition;
*getNumParameters = *LibSBMLc::Model_getNumParameters;
*getNumRules = *LibSBMLc::Model_getNumRules;
*getNumReactions = *LibSBMLc::Model_getNumReactions;
*getNumEvents = *LibSBMLc::Model_getNumEvents;
*isBoolean = *LibSBMLc::Model_isBoolean;
sub DISOWN {
    my $self = shift;
    my $ptr = tied(%$self);
    delete $OWNER{$ptr};
}

sub ACQUIRE {
    my $self = shift;
    my $ptr = tied(%$self);
    $OWNER{$ptr} = 1;
}


############# Class : LibSBML::SBMLDocument ##############

package LibSBML::SBMLDocument;
@ISA = qw( LibSBML LibSBML::SBase );
%OWNER = ();
%ITERATORS = ();
sub new {
    my $pkg = shift;
    my $self = LibSBMLc::new_SBMLDocument(@_);
    bless $self, $pkg if defined($self);
}

sub DESTROY {
    return unless $_[0]->isa('HASH');
    my $self = tied(%{$_[0]});
    return unless defined $self;
    delete $ITERATORS{$self};
    if (exists $OWNER{$self}) {
        LibSBMLc::delete_SBMLDocument($self);
        delete $OWNER{$self};
    }
}

*createModel = *LibSBMLc::SBMLDocument_createModel;
*getLevel = *LibSBMLc::SBMLDocument_getLevel;
*getVersion = *LibSBMLc::SBMLDocument_getVersion;
*getModel = *LibSBMLc::SBMLDocument_getModel;
*getWarning = *LibSBMLc::SBMLDocument_getWarning;
*getError = *LibSBMLc::SBMLDocument_getError;
*getFatal = *LibSBMLc::SBMLDocument_getFatal;
*getNumWarnings = *LibSBMLc::SBMLDocument_getNumWarnings;
*getNumErrors = *LibSBMLc::SBMLDocument_getNumErrors;
*getNumFatals = *LibSBMLc::SBMLDocument_getNumFatals;
*setLevel = *LibSBMLc::SBMLDocument_setLevel;
*setVersion = *LibSBMLc::SBMLDocument_setVersion;
sub setModel {
  $_[1]->DISOWN() if defined $_[1];
  return LibSBMLc::SBMLDocument_setModel(@_);
}

*checkConsistency = *LibSBMLc::SBMLDocument_checkConsistency;
*validate = *LibSBMLc::SBMLDocument_validate;
*checkL1Compatibility = *LibSBMLc::SBMLDocument_checkL1Compatibility;
sub DISOWN {
    my $self = shift;
    my $ptr = tied(%$self);
    delete $OWNER{$ptr};
}

sub ACQUIRE {
    my $self = shift;
    my $ptr = tied(%$self);
    $OWNER{$ptr} = 1;
}


############# Class : LibSBML::FunctionDefinition ##############

package LibSBML::FunctionDefinition;
@ISA = qw( LibSBML LibSBML::SBase );
%OWNER = ();
%ITERATORS = ();
sub new {
  my $pkg = shift;
  $_[1]->DISOWN() if defined $_[1] && ref($_[1]) eq 'LibSBML::ASTNode';
  my $self = LibSBMLc::new_FunctionDefinition(@_);
  bless $self, $pkg if defined($self);
}

sub DESTROY {
    return unless $_[0]->isa('HASH');
    my $self = tied(%{$_[0]});
    return unless defined $self;
    delete $ITERATORS{$self};
    if (exists $OWNER{$self}) {
        LibSBMLc::delete_FunctionDefinition($self);
        delete $OWNER{$self};
    }
}

*getId = *LibSBMLc::FunctionDefinition_getId;
*getName = *LibSBMLc::FunctionDefinition_getName;
*getMath = *LibSBMLc::FunctionDefinition_getMath;
*isSetId = *LibSBMLc::FunctionDefinition_isSetId;
*isSetName = *LibSBMLc::FunctionDefinition_isSetName;
*isSetMath = *LibSBMLc::FunctionDefinition_isSetMath;
*setId = *LibSBMLc::FunctionDefinition_setId;
*setName = *LibSBMLc::FunctionDefinition_setName;
sub setMath {
  $_[1]->DISOWN() if defined $_[1];
  return LibSBMLc::FunctionDefinition_setMath(@_);
}

*unsetName = *LibSBMLc::FunctionDefinition_unsetName;
sub DISOWN {
    my $self = shift;
    my $ptr = tied(%$self);
    delete $OWNER{$ptr};
}

sub ACQUIRE {
    my $self = shift;
    my $ptr = tied(%$self);
    $OWNER{$ptr} = 1;
}


############# Class : LibSBML::Unit ##############

package LibSBML::Unit;
@ISA = qw( LibSBML LibSBML::SBase );
%OWNER = ();
%ITERATORS = ();
sub new {
    my $pkg = shift;
    my $self = LibSBMLc::new_Unit(@_);
    bless $self, $pkg if defined($self);
}

sub DESTROY {
    return unless $_[0]->isa('HASH');
    my $self = tied(%{$_[0]});
    return unless defined $self;
    delete $ITERATORS{$self};
    if (exists $OWNER{$self}) {
        LibSBMLc::delete_Unit($self);
        delete $OWNER{$self};
    }
}

*initDefaults = *LibSBMLc::Unit_initDefaults;
*getKind = *LibSBMLc::Unit_getKind;
*getExponent = *LibSBMLc::Unit_getExponent;
*getScale = *LibSBMLc::Unit_getScale;
*getMultiplier = *LibSBMLc::Unit_getMultiplier;
*getOffset = *LibSBMLc::Unit_getOffset;
*isAmpere = *LibSBMLc::Unit_isAmpere;
*isBecquerel = *LibSBMLc::Unit_isBecquerel;
*isCandela = *LibSBMLc::Unit_isCandela;
*isCelsius = *LibSBMLc::Unit_isCelsius;
*isCoulomb = *LibSBMLc::Unit_isCoulomb;
*isDimensionless = *LibSBMLc::Unit_isDimensionless;
*isFarad = *LibSBMLc::Unit_isFarad;
*isGram = *LibSBMLc::Unit_isGram;
*isGray = *LibSBMLc::Unit_isGray;
*isHenry = *LibSBMLc::Unit_isHenry;
*isHertz = *LibSBMLc::Unit_isHertz;
*isItem = *LibSBMLc::Unit_isItem;
*isJoule = *LibSBMLc::Unit_isJoule;
*isKatal = *LibSBMLc::Unit_isKatal;
*isKelvin = *LibSBMLc::Unit_isKelvin;
*isKilogram = *LibSBMLc::Unit_isKilogram;
*isLitre = *LibSBMLc::Unit_isLitre;
*isLumen = *LibSBMLc::Unit_isLumen;
*isLux = *LibSBMLc::Unit_isLux;
*isMetre = *LibSBMLc::Unit_isMetre;
*isMole = *LibSBMLc::Unit_isMole;
*isNewton = *LibSBMLc::Unit_isNewton;
*isOhm = *LibSBMLc::Unit_isOhm;
*isPascal = *LibSBMLc::Unit_isPascal;
*isRadian = *LibSBMLc::Unit_isRadian;
*isSecond = *LibSBMLc::Unit_isSecond;
*isSiemens = *LibSBMLc::Unit_isSiemens;
*isSievert = *LibSBMLc::Unit_isSievert;
*isSteradian = *LibSBMLc::Unit_isSteradian;
*isTesla = *LibSBMLc::Unit_isTesla;
*isVolt = *LibSBMLc::Unit_isVolt;
*isWatt = *LibSBMLc::Unit_isWatt;
*isWeber = *LibSBMLc::Unit_isWeber;
*isSetKind = *LibSBMLc::Unit_isSetKind;
*setKind = *LibSBMLc::Unit_setKind;
*setExponent = *LibSBMLc::Unit_setExponent;
*setScale = *LibSBMLc::Unit_setScale;
*setMultiplier = *LibSBMLc::Unit_setMultiplier;
*setOffset = *LibSBMLc::Unit_setOffset;
*isBuiltIn = *LibSBMLc::Unit_isBuiltIn;
*isUnitKind = *LibSBMLc::Unit_isUnitKind;
sub DISOWN {
    my $self = shift;
    my $ptr = tied(%$self);
    delete $OWNER{$ptr};
}

sub ACQUIRE {
    my $self = shift;
    my $ptr = tied(%$self);
    $OWNER{$ptr} = 1;
}


############# Class : LibSBML::UnitDefinition ##############

package LibSBML::UnitDefinition;
@ISA = qw( LibSBML LibSBML::SBase );
%OWNER = ();
%ITERATORS = ();
sub new {
    my $pkg = shift;
    my $self = LibSBMLc::new_UnitDefinition(@_);
    bless $self, $pkg if defined($self);
}

sub DESTROY {
    return unless $_[0]->isa('HASH');
    my $self = tied(%{$_[0]});
    return unless defined $self;
    delete $ITERATORS{$self};
    if (exists $OWNER{$self}) {
        LibSBMLc::delete_UnitDefinition($self);
        delete $OWNER{$self};
    }
}

*getId = *LibSBMLc::UnitDefinition_getId;
*getName = *LibSBMLc::UnitDefinition_getName;
*isSetId = *LibSBMLc::UnitDefinition_isSetId;
*isSetName = *LibSBMLc::UnitDefinition_isSetName;
*isVariantOfArea = *LibSBMLc::UnitDefinition_isVariantOfArea;
*isVariantOfLength = *LibSBMLc::UnitDefinition_isVariantOfLength;
*isVariantOfSubstance = *LibSBMLc::UnitDefinition_isVariantOfSubstance;
*isVariantOfTime = *LibSBMLc::UnitDefinition_isVariantOfTime;
*isVariantOfVolume = *LibSBMLc::UnitDefinition_isVariantOfVolume;
*moveIdToName = *LibSBMLc::UnitDefinition_moveIdToName;
*moveNameToId = *LibSBMLc::UnitDefinition_moveNameToId;
*setId = *LibSBMLc::UnitDefinition_setId;
*setName = *LibSBMLc::UnitDefinition_setName;
*unsetName = *LibSBMLc::UnitDefinition_unsetName;
sub addUnit {
  $_[1]->DISOWN() if defined $_[1];
  return LibSBMLc::UnitDefinition_addUnit(@_);
}

*getListOfUnits = *LibSBMLc::UnitDefinition_getListOfUnits;
*getUnit = *LibSBMLc::UnitDefinition_getUnit;
*getNumUnits = *LibSBMLc::UnitDefinition_getNumUnits;
sub DISOWN {
    my $self = shift;
    my $ptr = tied(%$self);
    delete $OWNER{$ptr};
}

sub ACQUIRE {
    my $self = shift;
    my $ptr = tied(%$self);
    $OWNER{$ptr} = 1;
}


############# Class : LibSBML::Compartment ##############

package LibSBML::Compartment;
@ISA = qw( LibSBML LibSBML::SBase );
%OWNER = ();
%ITERATORS = ();
sub new {
    my $pkg = shift;
    my $self = LibSBMLc::new_Compartment(@_);
    bless $self, $pkg if defined($self);
}

sub DESTROY {
    return unless $_[0]->isa('HASH');
    my $self = tied(%{$_[0]});
    return unless defined $self;
    delete $ITERATORS{$self};
    if (exists $OWNER{$self}) {
        LibSBMLc::delete_Compartment($self);
        delete $OWNER{$self};
    }
}

*initDefaults = *LibSBMLc::Compartment_initDefaults;
*getId = *LibSBMLc::Compartment_getId;
*getName = *LibSBMLc::Compartment_getName;
*getSpatialDimensions = *LibSBMLc::Compartment_getSpatialDimensions;
*getSize = *LibSBMLc::Compartment_getSize;
*getVolume = *LibSBMLc::Compartment_getVolume;
*getUnits = *LibSBMLc::Compartment_getUnits;
*getOutside = *LibSBMLc::Compartment_getOutside;
*getConstant = *LibSBMLc::Compartment_getConstant;
*isSetId = *LibSBMLc::Compartment_isSetId;
*isSetName = *LibSBMLc::Compartment_isSetName;
*isSetSize = *LibSBMLc::Compartment_isSetSize;
*isSetVolume = *LibSBMLc::Compartment_isSetVolume;
*isSetUnits = *LibSBMLc::Compartment_isSetUnits;
*isSetOutside = *LibSBMLc::Compartment_isSetOutside;
*moveIdToName = *LibSBMLc::Compartment_moveIdToName;
*moveNameToId = *LibSBMLc::Compartment_moveNameToId;
*setId = *LibSBMLc::Compartment_setId;
*setName = *LibSBMLc::Compartment_setName;
*setSpatialDimensions = *LibSBMLc::Compartment_setSpatialDimensions;
*setSize = *LibSBMLc::Compartment_setSize;
*setVolume = *LibSBMLc::Compartment_setVolume;
*setUnits = *LibSBMLc::Compartment_setUnits;
*setOutside = *LibSBMLc::Compartment_setOutside;
*setConstant = *LibSBMLc::Compartment_setConstant;
*unsetName = *LibSBMLc::Compartment_unsetName;
*unsetSize = *LibSBMLc::Compartment_unsetSize;
*unsetVolume = *LibSBMLc::Compartment_unsetVolume;
*unsetUnits = *LibSBMLc::Compartment_unsetUnits;
*unsetOutside = *LibSBMLc::Compartment_unsetOutside;
sub DISOWN {
    my $self = shift;
    my $ptr = tied(%$self);
    delete $OWNER{$ptr};
}

sub ACQUIRE {
    my $self = shift;
    my $ptr = tied(%$self);
    $OWNER{$ptr} = 1;
}


############# Class : LibSBML::Species ##############

package LibSBML::Species;
@ISA = qw( LibSBML LibSBML::SBase );
%OWNER = ();
%ITERATORS = ();
sub new {
    my $pkg = shift;
    my $self = LibSBMLc::new_Species(@_);
    bless $self, $pkg if defined($self);
}

sub DESTROY {
    return unless $_[0]->isa('HASH');
    my $self = tied(%{$_[0]});
    return unless defined $self;
    delete $ITERATORS{$self};
    if (exists $OWNER{$self}) {
        LibSBMLc::delete_Species($self);
        delete $OWNER{$self};
    }
}

*initDefaults = *LibSBMLc::Species_initDefaults;
*getId = *LibSBMLc::Species_getId;
*getName = *LibSBMLc::Species_getName;
*getCompartment = *LibSBMLc::Species_getCompartment;
*getInitialAmount = *LibSBMLc::Species_getInitialAmount;
*getInitialConcentration = *LibSBMLc::Species_getInitialConcentration;
*getSubstanceUnits = *LibSBMLc::Species_getSubstanceUnits;
*getSpatialSizeUnits = *LibSBMLc::Species_getSpatialSizeUnits;
*getUnits = *LibSBMLc::Species_getUnits;
*getHasOnlySubstanceUnits = *LibSBMLc::Species_getHasOnlySubstanceUnits;
*getBoundaryCondition = *LibSBMLc::Species_getBoundaryCondition;
*getCharge = *LibSBMLc::Species_getCharge;
*getConstant = *LibSBMLc::Species_getConstant;
*isSetId = *LibSBMLc::Species_isSetId;
*isSetName = *LibSBMLc::Species_isSetName;
*isSetCompartment = *LibSBMLc::Species_isSetCompartment;
*isSetInitialAmount = *LibSBMLc::Species_isSetInitialAmount;
*isSetInitialConcentration = *LibSBMLc::Species_isSetInitialConcentration;
*isSetSubstanceUnits = *LibSBMLc::Species_isSetSubstanceUnits;
*isSetSpatialSizeUnits = *LibSBMLc::Species_isSetSpatialSizeUnits;
*isSetUnits = *LibSBMLc::Species_isSetUnits;
*isSetCharge = *LibSBMLc::Species_isSetCharge;
*moveIdToName = *LibSBMLc::Species_moveIdToName;
*moveNameToId = *LibSBMLc::Species_moveNameToId;
*setId = *LibSBMLc::Species_setId;
*setName = *LibSBMLc::Species_setName;
*setCompartment = *LibSBMLc::Species_setCompartment;
*setInitialAmount = *LibSBMLc::Species_setInitialAmount;
*setInitialConcentration = *LibSBMLc::Species_setInitialConcentration;
*setSubstanceUnits = *LibSBMLc::Species_setSubstanceUnits;
*setSpatialSizeUnits = *LibSBMLc::Species_setSpatialSizeUnits;
*setUnits = *LibSBMLc::Species_setUnits;
*setHasOnlySubstanceUnits = *LibSBMLc::Species_setHasOnlySubstanceUnits;
*setBoundaryCondition = *LibSBMLc::Species_setBoundaryCondition;
*setCharge = *LibSBMLc::Species_setCharge;
*setConstant = *LibSBMLc::Species_setConstant;
*unsetName = *LibSBMLc::Species_unsetName;
*unsetInitialAmount = *LibSBMLc::Species_unsetInitialAmount;
*unsetInitialConcentration = *LibSBMLc::Species_unsetInitialConcentration;
*unsetSubstanceUnits = *LibSBMLc::Species_unsetSubstanceUnits;
*unsetSpatialSizeUnits = *LibSBMLc::Species_unsetSpatialSizeUnits;
*unsetUnits = *LibSBMLc::Species_unsetUnits;
*unsetCharge = *LibSBMLc::Species_unsetCharge;
sub DISOWN {
    my $self = shift;
    my $ptr = tied(%$self);
    delete $OWNER{$ptr};
}

sub ACQUIRE {
    my $self = shift;
    my $ptr = tied(%$self);
    $OWNER{$ptr} = 1;
}


############# Class : LibSBML::Parameter ##############

package LibSBML::Parameter;
@ISA = qw( LibSBML LibSBML::SBase );
%OWNER = ();
%ITERATORS = ();
sub new {
    my $pkg = shift;
    my $self = LibSBMLc::new_Parameter(@_);
    bless $self, $pkg if defined($self);
}

sub DESTROY {
    return unless $_[0]->isa('HASH');
    my $self = tied(%{$_[0]});
    return unless defined $self;
    delete $ITERATORS{$self};
    if (exists $OWNER{$self}) {
        LibSBMLc::delete_Parameter($self);
        delete $OWNER{$self};
    }
}

*initDefaults = *LibSBMLc::Parameter_initDefaults;
*getId = *LibSBMLc::Parameter_getId;
*getName = *LibSBMLc::Parameter_getName;
*getValue = *LibSBMLc::Parameter_getValue;
*getUnits = *LibSBMLc::Parameter_getUnits;
*getConstant = *LibSBMLc::Parameter_getConstant;
*isSetId = *LibSBMLc::Parameter_isSetId;
*isSetName = *LibSBMLc::Parameter_isSetName;
*isSetValue = *LibSBMLc::Parameter_isSetValue;
*isSetUnits = *LibSBMLc::Parameter_isSetUnits;
*moveIdToName = *LibSBMLc::Parameter_moveIdToName;
*moveNameToId = *LibSBMLc::Parameter_moveNameToId;
*setId = *LibSBMLc::Parameter_setId;
*setName = *LibSBMLc::Parameter_setName;
*setValue = *LibSBMLc::Parameter_setValue;
*setUnits = *LibSBMLc::Parameter_setUnits;
*setConstant = *LibSBMLc::Parameter_setConstant;
*unsetName = *LibSBMLc::Parameter_unsetName;
*unsetValue = *LibSBMLc::Parameter_unsetValue;
*unsetUnits = *LibSBMLc::Parameter_unsetUnits;
sub DISOWN {
    my $self = shift;
    my $ptr = tied(%$self);
    delete $OWNER{$ptr};
}

sub ACQUIRE {
    my $self = shift;
    my $ptr = tied(%$self);
    $OWNER{$ptr} = 1;
}


############# Class : LibSBML::Rule ##############

package LibSBML::Rule;
@ISA = qw( LibSBML LibSBML::SBase );
%OWNER = ();
%ITERATORS = ();
sub new {
    my $pkg = shift;
    my $self = LibSBMLc::new_Rule(@_);
    bless $self, $pkg if defined($self);
}

sub DESTROY {
    return unless $_[0]->isa('HASH');
    my $self = tied(%{$_[0]});
    return unless defined $self;
    delete $ITERATORS{$self};
    if (exists $OWNER{$self}) {
        LibSBMLc::delete_Rule($self);
        delete $OWNER{$self};
    }
}

*getFormula = *LibSBMLc::Rule_getFormula;
*getMath = *LibSBMLc::Rule_getMath;
*isSetFormula = *LibSBMLc::Rule_isSetFormula;
*isSetMath = *LibSBMLc::Rule_isSetMath;
*setFormula = *LibSBMLc::Rule_setFormula;
sub setMath {
  $_[1]->DISOWN() if defined $_[1];
  return LibSBMLc::Rule_setMath(@_);
}

*setFormulaFromMath = *LibSBMLc::Rule_setFormulaFromMath;
*setMathFromFormula = *LibSBMLc::Rule_setMathFromFormula;
sub DISOWN {
    my $self = shift;
    my $ptr = tied(%$self);
    delete $OWNER{$ptr};
}

sub ACQUIRE {
    my $self = shift;
    my $ptr = tied(%$self);
    $OWNER{$ptr} = 1;
}


############# Class : LibSBML::AlgebraicRule ##############

package LibSBML::AlgebraicRule;
@ISA = qw( LibSBML LibSBML::Rule );
%OWNER = ();
%ITERATORS = ();
sub new {
  my $pkg = shift;
  $_[0]->DISOWN() if defined $_[0] && ref($_[0]) eq 'LibSBML::ASTNode';
  my $self = LibSBMLc::new_AlgebraicRule(@_);
  bless $self, $pkg if defined($self);
}

sub DESTROY {
    return unless $_[0]->isa('HASH');
    my $self = tied(%{$_[0]});
    return unless defined $self;
    delete $ITERATORS{$self};
    if (exists $OWNER{$self}) {
        LibSBMLc::delete_AlgebraicRule($self);
        delete $OWNER{$self};
    }
}

sub DISOWN {
    my $self = shift;
    my $ptr = tied(%$self);
    delete $OWNER{$ptr};
}

sub ACQUIRE {
    my $self = shift;
    my $ptr = tied(%$self);
    $OWNER{$ptr} = 1;
}


############# Class : LibSBML::AssignmentRule ##############

package LibSBML::AssignmentRule;
@ISA = qw( LibSBML LibSBML::Rule );
%OWNER = ();
%ITERATORS = ();
sub new {
  my $pkg = shift;
  $_[1]->DISOWN() if defined $_[1] && ref($_[1]) eq 'LibSBML::ASTNode';
  my $self = LibSBMLc::new_AssignmentRule(@_);
  bless $self, $pkg if defined($self);
}

sub DESTROY {
    return unless $_[0]->isa('HASH');
    my $self = tied(%{$_[0]});
    return unless defined $self;
    delete $ITERATORS{$self};
    if (exists $OWNER{$self}) {
        LibSBMLc::delete_AssignmentRule($self);
        delete $OWNER{$self};
    }
}

*initDefaults = *LibSBMLc::AssignmentRule_initDefaults;
*getType = *LibSBMLc::AssignmentRule_getType;
*getVariable = *LibSBMLc::AssignmentRule_getVariable;
*isSetVariable = *LibSBMLc::AssignmentRule_isSetVariable;
*setType = *LibSBMLc::AssignmentRule_setType;
*setVariable = *LibSBMLc::AssignmentRule_setVariable;
sub DISOWN {
    my $self = shift;
    my $ptr = tied(%$self);
    delete $OWNER{$ptr};
}

sub ACQUIRE {
    my $self = shift;
    my $ptr = tied(%$self);
    $OWNER{$ptr} = 1;
}


############# Class : LibSBML::RateRule ##############

package LibSBML::RateRule;
@ISA = qw( LibSBML LibSBML::Rule );
%OWNER = ();
%ITERATORS = ();
sub new {
  my $pkg = shift;
  $_[1]->DISOWN() if defined $_[1] && ref($_[1]) eq 'LibSBML::ASTNode';
  my $self = LibSBMLc::new_RateRule(@_);
  bless $self, $pkg if defined($self);
}

sub DESTROY {
    return unless $_[0]->isa('HASH');
    my $self = tied(%{$_[0]});
    return unless defined $self;
    delete $ITERATORS{$self};
    if (exists $OWNER{$self}) {
        LibSBMLc::delete_RateRule($self);
        delete $OWNER{$self};
    }
}

*getVariable = *LibSBMLc::RateRule_getVariable;
*isSetVariable = *LibSBMLc::RateRule_isSetVariable;
*setVariable = *LibSBMLc::RateRule_setVariable;
sub DISOWN {
    my $self = shift;
    my $ptr = tied(%$self);
    delete $OWNER{$ptr};
}

sub ACQUIRE {
    my $self = shift;
    my $ptr = tied(%$self);
    $OWNER{$ptr} = 1;
}


############# Class : LibSBML::SpeciesConcentrationRule ##############

package LibSBML::SpeciesConcentrationRule;
@ISA = qw( LibSBML LibSBML::AssignmentRule );
%OWNER = ();
%ITERATORS = ();
sub new {
    my $pkg = shift;
    my $self = LibSBMLc::new_SpeciesConcentrationRule(@_);
    bless $self, $pkg if defined($self);
}

sub DESTROY {
    return unless $_[0]->isa('HASH');
    my $self = tied(%{$_[0]});
    return unless defined $self;
    delete $ITERATORS{$self};
    if (exists $OWNER{$self}) {
        LibSBMLc::delete_SpeciesConcentrationRule($self);
        delete $OWNER{$self};
    }
}

*getSpecies = *LibSBMLc::SpeciesConcentrationRule_getSpecies;
*isSetSpecies = *LibSBMLc::SpeciesConcentrationRule_isSetSpecies;
*setSpecies = *LibSBMLc::SpeciesConcentrationRule_setSpecies;
sub DISOWN {
    my $self = shift;
    my $ptr = tied(%$self);
    delete $OWNER{$ptr};
}

sub ACQUIRE {
    my $self = shift;
    my $ptr = tied(%$self);
    $OWNER{$ptr} = 1;
}


############# Class : LibSBML::CompartmentVolumeRule ##############

package LibSBML::CompartmentVolumeRule;
@ISA = qw( LibSBML LibSBML::AssignmentRule );
%OWNER = ();
%ITERATORS = ();
sub new {
    my $pkg = shift;
    my $self = LibSBMLc::new_CompartmentVolumeRule(@_);
    bless $self, $pkg if defined($self);
}

sub DESTROY {
    return unless $_[0]->isa('HASH');
    my $self = tied(%{$_[0]});
    return unless defined $self;
    delete $ITERATORS{$self};
    if (exists $OWNER{$self}) {
        LibSBMLc::delete_CompartmentVolumeRule($self);
        delete $OWNER{$self};
    }
}

*getCompartment = *LibSBMLc::CompartmentVolumeRule_getCompartment;
*isSetCompartment = *LibSBMLc::CompartmentVolumeRule_isSetCompartment;
*setCompartment = *LibSBMLc::CompartmentVolumeRule_setCompartment;
sub DISOWN {
    my $self = shift;
    my $ptr = tied(%$self);
    delete $OWNER{$ptr};
}

sub ACQUIRE {
    my $self = shift;
    my $ptr = tied(%$self);
    $OWNER{$ptr} = 1;
}


############# Class : LibSBML::ParameterRule ##############

package LibSBML::ParameterRule;
@ISA = qw( LibSBML LibSBML::AssignmentRule );
%OWNER = ();
%ITERATORS = ();
sub new {
    my $pkg = shift;
    my $self = LibSBMLc::new_ParameterRule(@_);
    bless $self, $pkg if defined($self);
}

sub DESTROY {
    return unless $_[0]->isa('HASH');
    my $self = tied(%{$_[0]});
    return unless defined $self;
    delete $ITERATORS{$self};
    if (exists $OWNER{$self}) {
        LibSBMLc::delete_ParameterRule($self);
        delete $OWNER{$self};
    }
}

*getName = *LibSBMLc::ParameterRule_getName;
*getUnits = *LibSBMLc::ParameterRule_getUnits;
*isSetName = *LibSBMLc::ParameterRule_isSetName;
*isSetUnits = *LibSBMLc::ParameterRule_isSetUnits;
*setName = *LibSBMLc::ParameterRule_setName;
*setUnits = *LibSBMLc::ParameterRule_setUnits;
*unsetUnits = *LibSBMLc::ParameterRule_unsetUnits;
sub DISOWN {
    my $self = shift;
    my $ptr = tied(%$self);
    delete $OWNER{$ptr};
}

sub ACQUIRE {
    my $self = shift;
    my $ptr = tied(%$self);
    $OWNER{$ptr} = 1;
}


############# Class : LibSBML::Reaction ##############

package LibSBML::Reaction;
@ISA = qw( LibSBML LibSBML::SBase );
%OWNER = ();
%ITERATORS = ();
sub new {
    my $pkg = shift;
    my $self = LibSBMLc::new_Reaction(@_);
    bless $self, $pkg if defined($self);
}

sub DESTROY {
    return unless $_[0]->isa('HASH');
    my $self = tied(%{$_[0]});
    return unless defined $self;
    delete $ITERATORS{$self};
    if (exists $OWNER{$self}) {
        LibSBMLc::delete_Reaction($self);
        delete $OWNER{$self};
    }
}

*initDefaults = *LibSBMLc::Reaction_initDefaults;
*getId = *LibSBMLc::Reaction_getId;
*getName = *LibSBMLc::Reaction_getName;
*getKineticLaw = *LibSBMLc::Reaction_getKineticLaw;
*getReversible = *LibSBMLc::Reaction_getReversible;
*getFast = *LibSBMLc::Reaction_getFast;
*isSetId = *LibSBMLc::Reaction_isSetId;
*isSetName = *LibSBMLc::Reaction_isSetName;
*isSetKineticLaw = *LibSBMLc::Reaction_isSetKineticLaw;
*isSetFast = *LibSBMLc::Reaction_isSetFast;
*moveIdToName = *LibSBMLc::Reaction_moveIdToName;
*moveNameToId = *LibSBMLc::Reaction_moveNameToId;
*setId = *LibSBMLc::Reaction_setId;
*setName = *LibSBMLc::Reaction_setName;
sub setKineticLaw {
  $_[1]->DISOWN() if defined $_[1];
  return LibSBMLc::Reaction_setKineticLaw(@_);
}

*setReversible = *LibSBMLc::Reaction_setReversible;
*setFast = *LibSBMLc::Reaction_setFast;
sub addReactant {
  $_[1]->DISOWN() if defined $_[1];
  return LibSBMLc::Reaction_addReactant(@_);
}

sub addProduct {
  $_[1]->DISOWN() if defined $_[1];
  return LibSBMLc::Reaction_addProduct(@_);
}

sub addModifier {
  $_[1]->DISOWN() if defined $_[1];
  return LibSBMLc::Reaction_addModifier(@_);
}

*getListOfReactants = *LibSBMLc::Reaction_getListOfReactants;
*getListOfProducts = *LibSBMLc::Reaction_getListOfProducts;
*getListOfModifiers = *LibSBMLc::Reaction_getListOfModifiers;
*getReactant = *LibSBMLc::Reaction_getReactant;
*getProduct = *LibSBMLc::Reaction_getProduct;
*getModifier = *LibSBMLc::Reaction_getModifier;
*getNumReactants = *LibSBMLc::Reaction_getNumReactants;
*getNumProducts = *LibSBMLc::Reaction_getNumProducts;
*getNumModifiers = *LibSBMLc::Reaction_getNumModifiers;
*unsetName = *LibSBMLc::Reaction_unsetName;
*unsetKineticLaw = *LibSBMLc::Reaction_unsetKineticLaw;
*unsetFast = *LibSBMLc::Reaction_unsetFast;
sub DISOWN {
    my $self = shift;
    my $ptr = tied(%$self);
    delete $OWNER{$ptr};
}

sub ACQUIRE {
    my $self = shift;
    my $ptr = tied(%$self);
    $OWNER{$ptr} = 1;
}


############# Class : LibSBML::KineticLaw ##############

package LibSBML::KineticLaw;
@ISA = qw( LibSBML LibSBML::SBase );
%OWNER = ();
%ITERATORS = ();
sub new {
    my $pkg = shift;
    my $self = LibSBMLc::new_KineticLaw(@_);
    bless $self, $pkg if defined($self);
}

sub DESTROY {
    return unless $_[0]->isa('HASH');
    my $self = tied(%{$_[0]});
    return unless defined $self;
    delete $ITERATORS{$self};
    if (exists $OWNER{$self}) {
        LibSBMLc::delete_KineticLaw($self);
        delete $OWNER{$self};
    }
}

*getFormula = *LibSBMLc::KineticLaw_getFormula;
*getMath = *LibSBMLc::KineticLaw_getMath;
*getListOfParameters = *LibSBMLc::KineticLaw_getListOfParameters;
*getTimeUnits = *LibSBMLc::KineticLaw_getTimeUnits;
*getSubstanceUnits = *LibSBMLc::KineticLaw_getSubstanceUnits;
*isSetFormula = *LibSBMLc::KineticLaw_isSetFormula;
*isSetMath = *LibSBMLc::KineticLaw_isSetMath;
*isSetTimeUnits = *LibSBMLc::KineticLaw_isSetTimeUnits;
*isSetSubstanceUnits = *LibSBMLc::KineticLaw_isSetSubstanceUnits;
*setFormula = *LibSBMLc::KineticLaw_setFormula;
sub setMath {
  $_[1]->DISOWN() if defined $_[1];
  return LibSBMLc::KineticLaw_setMath(@_);
}

*setFormulaFromMath = *LibSBMLc::KineticLaw_setFormulaFromMath;
*setMathFromFormula = *LibSBMLc::KineticLaw_setMathFromFormula;
*setTimeUnits = *LibSBMLc::KineticLaw_setTimeUnits;
*setSubstanceUnits = *LibSBMLc::KineticLaw_setSubstanceUnits;
sub addParameter {
  $_[1]->DISOWN() if defined $_[1];
  return LibSBMLc::KineticLaw_addParameter(@_);
}

*getParameter = *LibSBMLc::KineticLaw_getParameter;
*getNumParameters = *LibSBMLc::KineticLaw_getNumParameters;
*unsetTimeUnits = *LibSBMLc::KineticLaw_unsetTimeUnits;
*unsetSubstanceUnits = *LibSBMLc::KineticLaw_unsetSubstanceUnits;
sub DISOWN {
    my $self = shift;
    my $ptr = tied(%$self);
    delete $OWNER{$ptr};
}

sub ACQUIRE {
    my $self = shift;
    my $ptr = tied(%$self);
    $OWNER{$ptr} = 1;
}


############# Class : LibSBML::SimpleSpeciesReference ##############

package LibSBML::SimpleSpeciesReference;
@ISA = qw( LibSBML LibSBML::SBase );
%OWNER = ();
%ITERATORS = ();
sub new {
    my $pkg = shift;
    my $self = LibSBMLc::new_SimpleSpeciesReference(@_);
    bless $self, $pkg if defined($self);
}

sub DESTROY {
    return unless $_[0]->isa('HASH');
    my $self = tied(%{$_[0]});
    return unless defined $self;
    delete $ITERATORS{$self};
    if (exists $OWNER{$self}) {
        LibSBMLc::delete_SimpleSpeciesReference($self);
        delete $OWNER{$self};
    }
}

*getSpecies = *LibSBMLc::SimpleSpeciesReference_getSpecies;
*isSetSpecies = *LibSBMLc::SimpleSpeciesReference_isSetSpecies;
*setSpecies = *LibSBMLc::SimpleSpeciesReference_setSpecies;
sub DISOWN {
    my $self = shift;
    my $ptr = tied(%$self);
    delete $OWNER{$ptr};
}

sub ACQUIRE {
    my $self = shift;
    my $ptr = tied(%$self);
    $OWNER{$ptr} = 1;
}


############# Class : LibSBML::SpeciesReference ##############

package LibSBML::SpeciesReference;
@ISA = qw( LibSBML LibSBML::SimpleSpeciesReference );
%OWNER = ();
%ITERATORS = ();
sub new {
    my $pkg = shift;
    my $self = LibSBMLc::new_SpeciesReference(@_);
    bless $self, $pkg if defined($self);
}

sub DESTROY {
    return unless $_[0]->isa('HASH');
    my $self = tied(%{$_[0]});
    return unless defined $self;
    delete $ITERATORS{$self};
    if (exists $OWNER{$self}) {
        LibSBMLc::delete_SpeciesReference($self);
        delete $OWNER{$self};
    }
}

*initDefaults = *LibSBMLc::SpeciesReference_initDefaults;
*getStoichiometry = *LibSBMLc::SpeciesReference_getStoichiometry;
*getStoichiometryMath = *LibSBMLc::SpeciesReference_getStoichiometryMath;
*getDenominator = *LibSBMLc::SpeciesReference_getDenominator;
*isSetStoichiometryMath = *LibSBMLc::SpeciesReference_isSetStoichiometryMath;
*setStoichiometry = *LibSBMLc::SpeciesReference_setStoichiometry;
sub setStoichiometryMath {
  $_[1]->DISOWN() if defined $_[1];
  return LibSBMLc::SpeciesReference_setStoichiometryMath(@_);
}

*setDenominator = *LibSBMLc::SpeciesReference_setDenominator;
sub DISOWN {
    my $self = shift;
    my $ptr = tied(%$self);
    delete $OWNER{$ptr};
}

sub ACQUIRE {
    my $self = shift;
    my $ptr = tied(%$self);
    $OWNER{$ptr} = 1;
}


############# Class : LibSBML::ModifierSpeciesReference ##############

package LibSBML::ModifierSpeciesReference;
@ISA = qw( LibSBML LibSBML::SimpleSpeciesReference );
%OWNER = ();
%ITERATORS = ();
sub new {
    my $pkg = shift;
    my $self = LibSBMLc::new_ModifierSpeciesReference(@_);
    bless $self, $pkg if defined($self);
}

sub DESTROY {
    return unless $_[0]->isa('HASH');
    my $self = tied(%{$_[0]});
    return unless defined $self;
    delete $ITERATORS{$self};
    if (exists $OWNER{$self}) {
        LibSBMLc::delete_ModifierSpeciesReference($self);
        delete $OWNER{$self};
    }
}

sub DISOWN {
    my $self = shift;
    my $ptr = tied(%$self);
    delete $OWNER{$ptr};
}

sub ACQUIRE {
    my $self = shift;
    my $ptr = tied(%$self);
    $OWNER{$ptr} = 1;
}


############# Class : LibSBML::Event ##############

package LibSBML::Event;
@ISA = qw( LibSBML LibSBML::SBase );
%OWNER = ();
%ITERATORS = ();
sub new {
  my $pkg = shift;
  $_[1]->DISOWN() if defined $_[1] && ref($_[1]) eq 'LibSBML::ASTNode';
  my $self = LibSBMLc::new_Event(@_);
  bless $self, $pkg if defined($self);
}

sub DESTROY {
    return unless $_[0]->isa('HASH');
    my $self = tied(%{$_[0]});
    return unless defined $self;
    delete $ITERATORS{$self};
    if (exists $OWNER{$self}) {
        LibSBMLc::delete_Event($self);
        delete $OWNER{$self};
    }
}

*getId = *LibSBMLc::Event_getId;
*getName = *LibSBMLc::Event_getName;
*getTrigger = *LibSBMLc::Event_getTrigger;
*getDelay = *LibSBMLc::Event_getDelay;
*getTimeUnits = *LibSBMLc::Event_getTimeUnits;
*isSetId = *LibSBMLc::Event_isSetId;
*isSetName = *LibSBMLc::Event_isSetName;
*isSetTrigger = *LibSBMLc::Event_isSetTrigger;
*isSetDelay = *LibSBMLc::Event_isSetDelay;
*isSetTimeUnits = *LibSBMLc::Event_isSetTimeUnits;
*setId = *LibSBMLc::Event_setId;
*setName = *LibSBMLc::Event_setName;
sub setTrigger {
  $_[1]->DISOWN() if defined $_[1];
  return LibSBMLc::Event_setTrigger(@_);
}

sub setDelay {
  $_[1]->DISOWN() if defined $_[1];
  return LibSBMLc::Event_setDelay(@_);
}

*setTimeUnits = *LibSBMLc::Event_setTimeUnits;
*unsetId = *LibSBMLc::Event_unsetId;
*unsetName = *LibSBMLc::Event_unsetName;
*unsetDelay = *LibSBMLc::Event_unsetDelay;
*unsetTimeUnits = *LibSBMLc::Event_unsetTimeUnits;
sub addEventAssignment {
  $_[1]->DISOWN() if defined $_[1];
  return LibSBMLc::Event_addEventAssignment(@_);
}

*getListOfEventAssignments = *LibSBMLc::Event_getListOfEventAssignments;
*getEventAssignment = *LibSBMLc::Event_getEventAssignment;
*getNumEventAssignments = *LibSBMLc::Event_getNumEventAssignments;
sub DISOWN {
    my $self = shift;
    my $ptr = tied(%$self);
    delete $OWNER{$ptr};
}

sub ACQUIRE {
    my $self = shift;
    my $ptr = tied(%$self);
    $OWNER{$ptr} = 1;
}


############# Class : LibSBML::EventAssignment ##############

package LibSBML::EventAssignment;
@ISA = qw( LibSBML LibSBML::SBase );
%OWNER = ();
%ITERATORS = ();
sub new {
  my $pkg = shift;
  $_[1]->DISOWN() if defined $_[1] && ref($_[1]) eq 'LibSBML::ASTNode';
  my $self = LibSBMLc::new_EventAssignment(@_);
  bless $self, $pkg if defined($self);
}

sub DESTROY {
    return unless $_[0]->isa('HASH');
    my $self = tied(%{$_[0]});
    return unless defined $self;
    delete $ITERATORS{$self};
    if (exists $OWNER{$self}) {
        LibSBMLc::delete_EventAssignment($self);
        delete $OWNER{$self};
    }
}

*getVariable = *LibSBMLc::EventAssignment_getVariable;
*getMath = *LibSBMLc::EventAssignment_getMath;
*isSetVariable = *LibSBMLc::EventAssignment_isSetVariable;
*isSetMath = *LibSBMLc::EventAssignment_isSetMath;
*setVariable = *LibSBMLc::EventAssignment_setVariable;
sub setMath {
  $_[1]->DISOWN() if defined $_[1];
  return LibSBMLc::EventAssignment_setMath(@_);
}

sub DISOWN {
    my $self = shift;
    my $ptr = tied(%$self);
    delete $OWNER{$ptr};
}

sub ACQUIRE {
    my $self = shift;
    my $ptr = tied(%$self);
    $OWNER{$ptr} = 1;
}


############# Class : LibSBML::MathMLWriter ##############

package LibSBML::MathMLWriter;
@ISA = qw( LibSBML );
%OWNER = ();
%ITERATORS = ();
sub new {
    my $pkg = shift;
    my $self = LibSBMLc::new_MathMLWriter(@_);
    bless $self, $pkg if defined($self);
}

sub DESTROY {
    return unless $_[0]->isa('HASH');
    my $self = tied(%{$_[0]});
    return unless defined $self;
    delete $ITERATORS{$self};
    if (exists $OWNER{$self}) {
        LibSBMLc::delete_MathMLWriter($self);
        delete $OWNER{$self};
    }
}

*write = *LibSBMLc::MathMLWriter_write;
*writeToString = *LibSBMLc::MathMLWriter_writeToString;
sub DISOWN {
    my $self = shift;
    my $ptr = tied(%$self);
    delete $OWNER{$ptr};
}

sub ACQUIRE {
    my $self = shift;
    my $ptr = tied(%$self);
    $OWNER{$ptr} = 1;
}


############# Class : LibSBML::ASTNode ##############

package LibSBML::ASTNode;
@ISA = qw( LibSBML );
%OWNER = ();
%ITERATORS = ();
sub new {
    my $pkg = shift;
    my $self = LibSBMLc::new_ASTNode(@_);
    bless $self, $pkg if defined($self);
}

sub DESTROY {
    return unless $_[0]->isa('HASH');
    my $self = tied(%{$_[0]});
    return unless defined $self;
    delete $ITERATORS{$self};
    if (exists $OWNER{$self}) {
        LibSBMLc::delete_ASTNode($self);
        delete $OWNER{$self};
    }
}

*canonicalize = *LibSBMLc::ASTNode_canonicalize;
sub addChild {
  $_[1]->DISOWN() if defined $_[1];
  return LibSBMLc::ASTNode_addChild(@_);
}

sub prependChild {
  $_[1]->DISOWN() if defined $_[1];
  return LibSBMLc::ASTNode_prependChild(@_);
}

*deepCopy = *LibSBMLc::ASTNode_deepCopy;
*getChild = *LibSBMLc::ASTNode_getChild;
*getLeftChild = *LibSBMLc::ASTNode_getLeftChild;
*getRightChild = *LibSBMLc::ASTNode_getRightChild;
*getNumChildren = *LibSBMLc::ASTNode_getNumChildren;
*getCharacter = *LibSBMLc::ASTNode_getCharacter;
*getInteger = *LibSBMLc::ASTNode_getInteger;
*getName = *LibSBMLc::ASTNode_getName;
*getNumerator = *LibSBMLc::ASTNode_getNumerator;
*getDenominator = *LibSBMLc::ASTNode_getDenominator;
*getReal = *LibSBMLc::ASTNode_getReal;
*getMantissa = *LibSBMLc::ASTNode_getMantissa;
*getExponent = *LibSBMLc::ASTNode_getExponent;
*getPrecedence = *LibSBMLc::ASTNode_getPrecedence;
*getType = *LibSBMLc::ASTNode_getType;
*isBoolean = *LibSBMLc::ASTNode_isBoolean;
*isConstant = *LibSBMLc::ASTNode_isConstant;
*isFunction = *LibSBMLc::ASTNode_isFunction;
*isInteger = *LibSBMLc::ASTNode_isInteger;
*isLambda = *LibSBMLc::ASTNode_isLambda;
*isLog10 = *LibSBMLc::ASTNode_isLog10;
*isLogical = *LibSBMLc::ASTNode_isLogical;
*isName = *LibSBMLc::ASTNode_isName;
*isNumber = *LibSBMLc::ASTNode_isNumber;
*isOperator = *LibSBMLc::ASTNode_isOperator;
*isRational = *LibSBMLc::ASTNode_isRational;
*isReal = *LibSBMLc::ASTNode_isReal;
*isRelational = *LibSBMLc::ASTNode_isRelational;
*isSqrt = *LibSBMLc::ASTNode_isSqrt;
*isUMinus = *LibSBMLc::ASTNode_isUMinus;
*isUnknown = *LibSBMLc::ASTNode_isUnknown;
*setCharacter = *LibSBMLc::ASTNode_setCharacter;
*setName = *LibSBMLc::ASTNode_setName;
*setValue = *LibSBMLc::ASTNode_setValue;
*setType = *LibSBMLc::ASTNode_setType;
sub DISOWN {
    my $self = shift;
    my $ptr = tied(%$self);
    delete $OWNER{$ptr};
}

sub ACQUIRE {
    my $self = shift;
    my $ptr = tied(%$self);
    $OWNER{$ptr} = 1;
}


############# Class : LibSBML::MathMLDocument ##############

package LibSBML::MathMLDocument;
@ISA = qw( LibSBML );
%OWNER = ();
%ITERATORS = ();
sub new {
    my $pkg = shift;
    my $self = LibSBMLc::new_MathMLDocument(@_);
    bless $self, $pkg if defined($self);
}

sub DESTROY {
    return unless $_[0]->isa('HASH');
    my $self = tied(%{$_[0]});
    return unless defined $self;
    delete $ITERATORS{$self};
    if (exists $OWNER{$self}) {
        LibSBMLc::delete_MathMLDocument($self);
        delete $OWNER{$self};
    }
}

*getMath = *LibSBMLc::MathMLDocument_getMath;
*isSetMath = *LibSBMLc::MathMLDocument_isSetMath;
sub setMath {
  $_[1]->DISOWN() if defined $_[1];
  return LibSBMLc::MathMLDocument_setMath(@_);
}

sub DISOWN {
    my $self = shift;
    my $ptr = tied(%$self);
    delete $OWNER{$ptr};
}

sub ACQUIRE {
    my $self = shift;
    my $ptr = tied(%$self);
    $OWNER{$ptr} = 1;
}


############# Class : LibSBML::ParseMessage ##############

package LibSBML::ParseMessage;
@ISA = qw( LibSBML );
%OWNER = ();
%ITERATORS = ();
sub new {
    my $pkg = shift;
    my $self = LibSBMLc::new_ParseMessage(@_);
    bless $self, $pkg if defined($self);
}

sub DESTROY {
    return unless $_[0]->isa('HASH');
    my $self = tied(%{$_[0]});
    return unless defined $self;
    delete $ITERATORS{$self};
    if (exists $OWNER{$self}) {
        LibSBMLc::delete_ParseMessage($self);
        delete $OWNER{$self};
    }
}

*getId = *LibSBMLc::ParseMessage_getId;
*getMessage = *LibSBMLc::ParseMessage_getMessage;
*getLine = *LibSBMLc::ParseMessage_getLine;
*getColumn = *LibSBMLc::ParseMessage_getColumn;
sub DISOWN {
    my $self = shift;
    my $ptr = tied(%$self);
    delete $OWNER{$ptr};
}

sub ACQUIRE {
    my $self = shift;
    my $ptr = tied(%$self);
    $OWNER{$ptr} = 1;
}


############# Class : LibSBML::XMLNamespace ##############

package LibSBML::XMLNamespace;
@ISA = qw( LibSBML );
%OWNER = ();
%ITERATORS = ();
sub new {
    my $pkg = shift;
    my $self = LibSBMLc::new_XMLNamespace(@_);
    bless $self, $pkg if defined($self);
}

*getPrefix = *LibSBMLc::XMLNamespace_getPrefix;
*getURI = *LibSBMLc::XMLNamespace_getURI;
*startsWithXMLNS = *LibSBMLc::XMLNamespace_startsWithXMLNS;
sub DESTROY {
    return unless $_[0]->isa('HASH');
    my $self = tied(%{$_[0]});
    return unless defined $self;
    delete $ITERATORS{$self};
    if (exists $OWNER{$self}) {
        LibSBMLc::delete_XMLNamespace($self);
        delete $OWNER{$self};
    }
}

sub DISOWN {
    my $self = shift;
    my $ptr = tied(%$self);
    delete $OWNER{$ptr};
}

sub ACQUIRE {
    my $self = shift;
    my $ptr = tied(%$self);
    $OWNER{$ptr} = 1;
}


############# Class : LibSBML::XMLNamespaceList ##############

package LibSBML::XMLNamespaceList;
@ISA = qw( LibSBML );
%OWNER = ();
%ITERATORS = ();
*add = *LibSBMLc::XMLNamespaceList_add;
*getLength = *LibSBMLc::XMLNamespaceList_getLength;
*getNamespace = *LibSBMLc::XMLNamespaceList_getNamespace;
*getPrefix = *LibSBMLc::XMLNamespaceList_getPrefix;
*getURI = *LibSBMLc::XMLNamespaceList_getURI;
sub new {
    my $pkg = shift;
    my $self = LibSBMLc::new_XMLNamespaceList(@_);
    bless $self, $pkg if defined($self);
}

sub DESTROY {
    return unless $_[0]->isa('HASH');
    my $self = tied(%{$_[0]});
    return unless defined $self;
    delete $ITERATORS{$self};
    if (exists $OWNER{$self}) {
        LibSBMLc::delete_XMLNamespaceList($self);
        delete $OWNER{$self};
    }
}

sub DISOWN {
    my $self = shift;
    my $ptr = tied(%$self);
    delete $OWNER{$ptr};
}

sub ACQUIRE {
    my $self = shift;
    my $ptr = tied(%$self);
    $OWNER{$ptr} = 1;
}


# ------- VARIABLE STUBS --------

package LibSBML;

*SBML_READ_ERROR_UNKNOWN = *LibSBMLc::SBML_READ_ERROR_UNKNOWN;
*SBML_READ_ERROR_FILE_NOT_FOUND = *LibSBMLc::SBML_READ_ERROR_FILE_NOT_FOUND;
*SBML_READ_ERROR_NOT_SBML = *LibSBMLc::SBML_READ_ERROR_NOT_SBML;
*SBML_UNKNOWN = *LibSBMLc::SBML_UNKNOWN;
*SBML_COMPARTMENT = *LibSBMLc::SBML_COMPARTMENT;
*SBML_DOCUMENT = *LibSBMLc::SBML_DOCUMENT;
*SBML_EVENT = *LibSBMLc::SBML_EVENT;
*SBML_EVENT_ASSIGNMENT = *LibSBMLc::SBML_EVENT_ASSIGNMENT;
*SBML_FUNCTION_DEFINITION = *LibSBMLc::SBML_FUNCTION_DEFINITION;
*SBML_KINETIC_LAW = *LibSBMLc::SBML_KINETIC_LAW;
*SBML_LIST_OF = *LibSBMLc::SBML_LIST_OF;
*SBML_MODEL = *LibSBMLc::SBML_MODEL;
*SBML_PARAMETER = *LibSBMLc::SBML_PARAMETER;
*SBML_REACTION = *LibSBMLc::SBML_REACTION;
*SBML_SPECIES = *LibSBMLc::SBML_SPECIES;
*SBML_SPECIES_REFERENCE = *LibSBMLc::SBML_SPECIES_REFERENCE;
*SBML_MODIFIER_SPECIES_REFERENCE = *LibSBMLc::SBML_MODIFIER_SPECIES_REFERENCE;
*SBML_UNIT_DEFINITION = *LibSBMLc::SBML_UNIT_DEFINITION;
*SBML_UNIT = *LibSBMLc::SBML_UNIT;
*SBML_ALGEBRAIC_RULE = *LibSBMLc::SBML_ALGEBRAIC_RULE;
*SBML_ASSIGNMENT_RULE = *LibSBMLc::SBML_ASSIGNMENT_RULE;
*SBML_RATE_RULE = *LibSBMLc::SBML_RATE_RULE;
*SBML_SPECIES_CONCENTRATION_RULE = *LibSBMLc::SBML_SPECIES_CONCENTRATION_RULE;
*SBML_COMPARTMENT_VOLUME_RULE = *LibSBMLc::SBML_COMPARTMENT_VOLUME_RULE;
*SBML_PARAMETER_RULE = *LibSBMLc::SBML_PARAMETER_RULE;
*UNIT_KIND_AMPERE = *LibSBMLc::UNIT_KIND_AMPERE;
*UNIT_KIND_BECQUEREL = *LibSBMLc::UNIT_KIND_BECQUEREL;
*UNIT_KIND_CANDELA = *LibSBMLc::UNIT_KIND_CANDELA;
*UNIT_KIND_CELSIUS = *LibSBMLc::UNIT_KIND_CELSIUS;
*UNIT_KIND_COULOMB = *LibSBMLc::UNIT_KIND_COULOMB;
*UNIT_KIND_DIMENSIONLESS = *LibSBMLc::UNIT_KIND_DIMENSIONLESS;
*UNIT_KIND_FARAD = *LibSBMLc::UNIT_KIND_FARAD;
*UNIT_KIND_GRAM = *LibSBMLc::UNIT_KIND_GRAM;
*UNIT_KIND_GRAY = *LibSBMLc::UNIT_KIND_GRAY;
*UNIT_KIND_HENRY = *LibSBMLc::UNIT_KIND_HENRY;
*UNIT_KIND_HERTZ = *LibSBMLc::UNIT_KIND_HERTZ;
*UNIT_KIND_ITEM = *LibSBMLc::UNIT_KIND_ITEM;
*UNIT_KIND_JOULE = *LibSBMLc::UNIT_KIND_JOULE;
*UNIT_KIND_KATAL = *LibSBMLc::UNIT_KIND_KATAL;
*UNIT_KIND_KELVIN = *LibSBMLc::UNIT_KIND_KELVIN;
*UNIT_KIND_KILOGRAM = *LibSBMLc::UNIT_KIND_KILOGRAM;
*UNIT_KIND_LITER = *LibSBMLc::UNIT_KIND_LITER;
*UNIT_KIND_LITRE = *LibSBMLc::UNIT_KIND_LITRE;
*UNIT_KIND_LUMEN = *LibSBMLc::UNIT_KIND_LUMEN;
*UNIT_KIND_LUX = *LibSBMLc::UNIT_KIND_LUX;
*UNIT_KIND_METER = *LibSBMLc::UNIT_KIND_METER;
*UNIT_KIND_METRE = *LibSBMLc::UNIT_KIND_METRE;
*UNIT_KIND_MOLE = *LibSBMLc::UNIT_KIND_MOLE;
*UNIT_KIND_NEWTON = *LibSBMLc::UNIT_KIND_NEWTON;
*UNIT_KIND_OHM = *LibSBMLc::UNIT_KIND_OHM;
*UNIT_KIND_PASCAL = *LibSBMLc::UNIT_KIND_PASCAL;
*UNIT_KIND_RADIAN = *LibSBMLc::UNIT_KIND_RADIAN;
*UNIT_KIND_SECOND = *LibSBMLc::UNIT_KIND_SECOND;
*UNIT_KIND_SIEMENS = *LibSBMLc::UNIT_KIND_SIEMENS;
*UNIT_KIND_SIEVERT = *LibSBMLc::UNIT_KIND_SIEVERT;
*UNIT_KIND_STERADIAN = *LibSBMLc::UNIT_KIND_STERADIAN;
*UNIT_KIND_TESLA = *LibSBMLc::UNIT_KIND_TESLA;
*UNIT_KIND_VOLT = *LibSBMLc::UNIT_KIND_VOLT;
*UNIT_KIND_WATT = *LibSBMLc::UNIT_KIND_WATT;
*UNIT_KIND_WEBER = *LibSBMLc::UNIT_KIND_WEBER;
*UNIT_KIND_INVALID = *LibSBMLc::UNIT_KIND_INVALID;
*RULE_TYPE_RATE = *LibSBMLc::RULE_TYPE_RATE;
*RULE_TYPE_SCALAR = *LibSBMLc::RULE_TYPE_SCALAR;
*RULE_TYPE_INVALID = *LibSBMLc::RULE_TYPE_INVALID;
*AST_PLUS = *LibSBMLc::AST_PLUS;
*AST_MINUS = *LibSBMLc::AST_MINUS;
*AST_TIMES = *LibSBMLc::AST_TIMES;
*AST_DIVIDE = *LibSBMLc::AST_DIVIDE;
*AST_POWER = *LibSBMLc::AST_POWER;
*AST_INTEGER = *LibSBMLc::AST_INTEGER;
*AST_REAL = *LibSBMLc::AST_REAL;
*AST_REAL_E = *LibSBMLc::AST_REAL_E;
*AST_RATIONAL = *LibSBMLc::AST_RATIONAL;
*AST_NAME = *LibSBMLc::AST_NAME;
*AST_NAME_TIME = *LibSBMLc::AST_NAME_TIME;
*AST_CONSTANT_E = *LibSBMLc::AST_CONSTANT_E;
*AST_CONSTANT_FALSE = *LibSBMLc::AST_CONSTANT_FALSE;
*AST_CONSTANT_PI = *LibSBMLc::AST_CONSTANT_PI;
*AST_CONSTANT_TRUE = *LibSBMLc::AST_CONSTANT_TRUE;
*AST_LAMBDA = *LibSBMLc::AST_LAMBDA;
*AST_FUNCTION = *LibSBMLc::AST_FUNCTION;
*AST_FUNCTION_ABS = *LibSBMLc::AST_FUNCTION_ABS;
*AST_FUNCTION_ARCCOS = *LibSBMLc::AST_FUNCTION_ARCCOS;
*AST_FUNCTION_ARCCOSH = *LibSBMLc::AST_FUNCTION_ARCCOSH;
*AST_FUNCTION_ARCCOT = *LibSBMLc::AST_FUNCTION_ARCCOT;
*AST_FUNCTION_ARCCOTH = *LibSBMLc::AST_FUNCTION_ARCCOTH;
*AST_FUNCTION_ARCCSC = *LibSBMLc::AST_FUNCTION_ARCCSC;
*AST_FUNCTION_ARCCSCH = *LibSBMLc::AST_FUNCTION_ARCCSCH;
*AST_FUNCTION_ARCSEC = *LibSBMLc::AST_FUNCTION_ARCSEC;
*AST_FUNCTION_ARCSECH = *LibSBMLc::AST_FUNCTION_ARCSECH;
*AST_FUNCTION_ARCSIN = *LibSBMLc::AST_FUNCTION_ARCSIN;
*AST_FUNCTION_ARCSINH = *LibSBMLc::AST_FUNCTION_ARCSINH;
*AST_FUNCTION_ARCTAN = *LibSBMLc::AST_FUNCTION_ARCTAN;
*AST_FUNCTION_ARCTANH = *LibSBMLc::AST_FUNCTION_ARCTANH;
*AST_FUNCTION_CEILING = *LibSBMLc::AST_FUNCTION_CEILING;
*AST_FUNCTION_COS = *LibSBMLc::AST_FUNCTION_COS;
*AST_FUNCTION_COSH = *LibSBMLc::AST_FUNCTION_COSH;
*AST_FUNCTION_COT = *LibSBMLc::AST_FUNCTION_COT;
*AST_FUNCTION_COTH = *LibSBMLc::AST_FUNCTION_COTH;
*AST_FUNCTION_CSC = *LibSBMLc::AST_FUNCTION_CSC;
*AST_FUNCTION_CSCH = *LibSBMLc::AST_FUNCTION_CSCH;
*AST_FUNCTION_DELAY = *LibSBMLc::AST_FUNCTION_DELAY;
*AST_FUNCTION_EXP = *LibSBMLc::AST_FUNCTION_EXP;
*AST_FUNCTION_FACTORIAL = *LibSBMLc::AST_FUNCTION_FACTORIAL;
*AST_FUNCTION_FLOOR = *LibSBMLc::AST_FUNCTION_FLOOR;
*AST_FUNCTION_LN = *LibSBMLc::AST_FUNCTION_LN;
*AST_FUNCTION_LOG = *LibSBMLc::AST_FUNCTION_LOG;
*AST_FUNCTION_PIECEWISE = *LibSBMLc::AST_FUNCTION_PIECEWISE;
*AST_FUNCTION_POWER = *LibSBMLc::AST_FUNCTION_POWER;
*AST_FUNCTION_ROOT = *LibSBMLc::AST_FUNCTION_ROOT;
*AST_FUNCTION_SEC = *LibSBMLc::AST_FUNCTION_SEC;
*AST_FUNCTION_SECH = *LibSBMLc::AST_FUNCTION_SECH;
*AST_FUNCTION_SIN = *LibSBMLc::AST_FUNCTION_SIN;
*AST_FUNCTION_SINH = *LibSBMLc::AST_FUNCTION_SINH;
*AST_FUNCTION_TAN = *LibSBMLc::AST_FUNCTION_TAN;
*AST_FUNCTION_TANH = *LibSBMLc::AST_FUNCTION_TANH;
*AST_LOGICAL_AND = *LibSBMLc::AST_LOGICAL_AND;
*AST_LOGICAL_NOT = *LibSBMLc::AST_LOGICAL_NOT;
*AST_LOGICAL_OR = *LibSBMLc::AST_LOGICAL_OR;
*AST_LOGICAL_XOR = *LibSBMLc::AST_LOGICAL_XOR;
*AST_RELATIONAL_EQ = *LibSBMLc::AST_RELATIONAL_EQ;
*AST_RELATIONAL_GEQ = *LibSBMLc::AST_RELATIONAL_GEQ;
*AST_RELATIONAL_GT = *LibSBMLc::AST_RELATIONAL_GT;
*AST_RELATIONAL_LEQ = *LibSBMLc::AST_RELATIONAL_LEQ;
*AST_RELATIONAL_LT = *LibSBMLc::AST_RELATIONAL_LT;
*AST_RELATIONAL_NEQ = *LibSBMLc::AST_RELATIONAL_NEQ;
*AST_UNKNOWN = *LibSBMLc::AST_UNKNOWN;
*XML_SCHEMA_VALIDATION_NONE = *LibSBMLc::XML_SCHEMA_VALIDATION_NONE;
*XML_SCHEMA_VALIDATION_BASIC = *LibSBMLc::XML_SCHEMA_VALIDATION_BASIC;
*XML_SCHEMA_VALIDATION_FULL = *LibSBMLc::XML_SCHEMA_VALIDATION_FULL;
1;
