/**
 * \file    L1CompatibilityValidator.h
 * \brief   Performs consistency checks on an SBML model to establish whether it
 *			can be converted from L2 to L1
 * \author  Sarah Keating
 *
 * $Id: L1CompatibilityValidator.cpp,v 1.2 2005/04/19 07:27:34 sarahkeating Exp $
 * $Source: /cvsroot/sbml/libsbml/src/validator/L1CompatibilityValidator.cpp,v $
 * */
/* Copyright 2005 California Institute of Technology and
 * Japan Science and Technology Corporation.
 *
 * This library is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as published
 * by the Free Software Foundation; either version 2.1 of the License, or
 * any later version.
 *
 * This library is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY, WITHOUT EVEN THE IMPLIED WARRANTY OF
 * MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.  The software and
 * documentation provided hereunder is on an "as is" basis, and the
 * California Institute of Technology and Japan Science and Technology
 * Corporation have no obligations to provide maintenance, support,
 * updates, enhancements or modifications.  In no event shall the
 * California Institute of Technology or the Japan Science and Technology
 * Corporation be liable to any party for direct, indirect, special,
 * incidental or consequential damages, including lost profits, arising
 * out of the use of this software and its documentation, even if the
 * California Institute of Technology and/or Japan Science and Technology
 * Corporation have been advised of the possibility of such damage.  See
 * the GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this library; if not, write to the Free Software Foundation,
 * Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA.
 *
 * The original code contained here was initially developed by:
 *
 *     Sarah Keating
 *
 *     The SBML Team
 *     STRI
 *     University of Hertfordshire
 *     Hatfield, UK
 *
 *     http://sbml.org
 *     mailto:sbml-team@caltech.edu
*
 * Contributor(s):
 */


#include "sbml/SBMLTypes.h"
#include "L1CompatibilityValidator.h"


/*
 * Compile L1CompatibilityConstraints
 */
#include "constraints/L1CompatibilityConstraints.cpp"


/**
 * Initializes this Validator with a set of Constraints.
 */
void
L1CompatibilityValidator::init ()
{
#define  AddingConstraintsToValidator 1
#include "constraints/L1CompatibilityConstraints.cpp"
}
