/**
 * \file    ExpatUnicodeChars.h
 * \brief   Definition of some Unicode characters
 * \author  Stefan Hoops <shoops@vt.edu>
 *
 * $Id: ExpatUnicodeChars.h,v 1.1 2005/03/28 22:38:24 bbornstein Exp $
 * $Source: /cvsroot/sbml/libsbml/src/xml/ExpatUnicodeChars.h,v $
 */
/* Copyright (c) 2003 Stefan Hoops
 *
 * Permission is hereby granted, free of charge, to any person obtaining
 * a copy of this software and associated documentation files (the
 * "Software"), to deal in the Software without restriction, including
 * without limitation the rights to use, copy, modify, merge, publish,
 * distribute, sublicense, and/or sell copies of the Software, and to
 * permit persons to whom the Software is furnished to do so, subject to
 * the following conditions:
 * 
 * The above copyright notice and this permission notice shall be
 * included in all copies or substantial portions of the Software.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
 * LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
 * OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
 * WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 *
 *  Contributor(s):
 */


#define chNull                   (XMLCh) 0x00
#define chHTab                   (XMLCh) 0x09
#define chLF                     (XMLCh) 0x0A
#define chVTab                   (XMLCh) 0x0B
#define chFF                     (XMLCh) 0x0C
#define chCR                     (XMLCh) 0x0D
#define chAmpersand              (XMLCh) 0x26
#define chAsterisk               (XMLCh) 0x2A
#define chAt                     (XMLCh) 0x40
#define chBackSlash              (XMLCh) 0x5C
#define chBang                   (XMLCh) 0x21
#define chCaret                  (XMLCh) 0x5E
#define chCloseAngle             (XMLCh) 0x3E
#define chCloseCurly             (XMLCh) 0x7D
#define chCloseParen             (XMLCh) 0x29
#define chCloseSquare            (XMLCh) 0x5D
#define chColon                  (XMLCh) 0x3A
#define chComma                  (XMLCh) 0x2C
#define chDash                   (XMLCh) 0x2D
#define chDollarSign             (XMLCh) 0x24
#define chDoubleQuote            (XMLCh) 0x22
#define chEqual                  (XMLCh) 0x3D
#define chForwardSlash           (XMLCh) 0x2F
#define chGrave                  (XMLCh) 0x60
#define chNEL                    (XMLCh) 0x85
#define chOpenAngle              (XMLCh) 0x3C
#define chOpenCurly              (XMLCh) 0x7B
#define chOpenParen              (XMLCh) 0x28
#define chOpenSquare             (XMLCh) 0x5B
#define chPercent                (XMLCh) 0x25
#define chPeriod                 (XMLCh) 0x2E
#define chPipe                   (XMLCh) 0x7C
#define chPlus                   (XMLCh) 0x2B
#define chPound                  (XMLCh) 0x23
#define chQuestion               (XMLCh) 0x3F
#define chSingleQuote            (XMLCh) 0x27
#define chSpace                  (XMLCh) 0x20
#define chSemiColon              (XMLCh) 0x3B
#define chTilde                  (XMLCh) 0x7E
#define chUnderscore             (XMLCh) 0x5F

/*
#define chSwappedUnicodeMarker   (XMLCh) 0xFFFE
#define chUnicodeMarker          (XMLCh) 0xFEFF
*/

#define chDigit_0                (XMLCh) 0x30
#define chDigit_1                (XMLCh) 0x31
#define chDigit_2                (XMLCh) 0x32
#define chDigit_3                (XMLCh) 0x33
#define chDigit_4                (XMLCh) 0x34
#define chDigit_5                (XMLCh) 0x35
#define chDigit_6                (XMLCh) 0x36
#define chDigit_7                (XMLCh) 0x37
#define chDigit_8                (XMLCh) 0x38
#define chDigit_9                (XMLCh) 0x39

#define chLatin_A                (XMLCh) 0x41
#define chLatin_B                (XMLCh) 0x42
#define chLatin_C                (XMLCh) 0x43
#define chLatin_D                (XMLCh) 0x44
#define chLatin_E                (XMLCh) 0x45
#define chLatin_F                (XMLCh) 0x46
#define chLatin_G                (XMLCh) 0x47
#define chLatin_H                (XMLCh) 0x48
#define chLatin_I                (XMLCh) 0x49
#define chLatin_J                (XMLCh) 0x4A
#define chLatin_K                (XMLCh) 0x4B
#define chLatin_L                (XMLCh) 0x4C
#define chLatin_M                (XMLCh) 0x4D
#define chLatin_N                (XMLCh) 0x4E
#define chLatin_O                (XMLCh) 0x4F
#define chLatin_P                (XMLCh) 0x50
#define chLatin_Q                (XMLCh) 0x51
#define chLatin_R                (XMLCh) 0x52
#define chLatin_S                (XMLCh) 0x53
#define chLatin_T                (XMLCh) 0x54
#define chLatin_U                (XMLCh) 0x55
#define chLatin_V                (XMLCh) 0x56
#define chLatin_W                (XMLCh) 0x57
#define chLatin_X                (XMLCh) 0x58
#define chLatin_Y                (XMLCh) 0x59
#define chLatin_Z                (XMLCh) 0x5A

#define chLatin_a                (XMLCh) 0x61
#define chLatin_b                (XMLCh) 0x62
#define chLatin_c                (XMLCh) 0x63
#define chLatin_d                (XMLCh) 0x64
#define chLatin_e                (XMLCh) 0x65
#define chLatin_f                (XMLCh) 0x66
#define chLatin_g                (XMLCh) 0x67
#define chLatin_h                (XMLCh) 0x68
#define chLatin_i                (XMLCh) 0x69
#define chLatin_j                (XMLCh) 0x6A
#define chLatin_k                (XMLCh) 0x6B
#define chLatin_l                (XMLCh) 0x6C
#define chLatin_m                (XMLCh) 0x6D
#define chLatin_n                (XMLCh) 0x6E
#define chLatin_o                (XMLCh) 0x6F
#define chLatin_p                (XMLCh) 0x70
#define chLatin_q                (XMLCh) 0x71
#define chLatin_r                (XMLCh) 0x72
#define chLatin_s                (XMLCh) 0x73
#define chLatin_t                (XMLCh) 0x74
#define chLatin_u                (XMLCh) 0x75
#define chLatin_v                (XMLCh) 0x76
#define chLatin_w                (XMLCh) 0x77
#define chLatin_x                (XMLCh) 0x78
#define chLatin_y                (XMLCh) 0x79
#define chLatin_z                (XMLCh) 0x7A

#define chYenSign                (XMLCh) 0xA5

/*
#define chWonSign                0x20A9

#define chLineSeparator          0x2028
#define chParagraphSeparator     0x2029
*/
